// public class gnu.java.security.provider.DSASignature

// class file dependencies
// @dep_class 72b2c34b8fa2f145 gnu_java_security_der_DERReader
// @dep_class 6370ccdc23537458 gnu_java_security_der_DERValue
// @dep_class 87aa78f6a77ed8b gnu_java_security_der_DERWriter
// @dep_class 3a4d5790dae5ac8a gnu_java_security_provider_DSASignature
// @dep_class a68cc27886fd8be3 java_io_ByteArrayInputStream
// @dep_class c4d3cc2bda03a338 java_io_ByteArrayOutputStream
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 4026d3144d6654d8 java_io_OutputStream
// @dep_class 42020e4665019671 java_lang_ArithmeticException
// @dep_class bf29ff960d5ec1d0 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 9cd7252f79299280 java_lang_Number
// @dep_class 2a7152deee1944f1 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c80f4aedd95be265 java_lang_String
// @dep_class a0a8fafccf4b2db9 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 7717ded55c30b7f3 java_math_BigInteger
// @dep_class 692089051f4c8d0b java_security_GeneralSecurityException
// @dep_class 327edce29f2562dd java_security_InvalidAlgorithmParameterException
// @dep_class 94dda41e9bf6c170 java_security_InvalidKeyException
// @dep_class 99827f89c0c36c1 java_security_InvalidParameterException
// @dep_class 965d036f0f33fac6 java_security_KeyException
// @dep_class cc2047cad8dcf75e java_security_MessageDigest
// @dep_class 22e937c2536160b4 java_security_NoSuchAlgorithmException
// @dep_class 8dfbf242adab91e java_security_NoSuchProviderException
// @dep_class dcdbe4a102f59043 java_security_PrivateKey
// @dep_class 4db3ac05e70e2bf8 java_security_PublicKey
// @dep_class 15c6a62b25a6e96d java_security_SecureRandom
// @dep_class 7ce2f2d523fa52ac java_security_SignatureException
// @dep_class 15e444274ebb7a6e java_security_SignatureSpi
// @dep_class f4f2d6013f72861e java_security_interfaces_DSAParams
// @dep_class d57e7f1f963e5163 java_security_interfaces_DSAPrivateKey
// @dep_class bad97fafc9653a27 java_security_interfaces_DSAPublicKey
// @dep_class ef2e5e8af121478f java_security_spec_AlgorithmParameterSpec
// @dep_class 8ea716c64b77f8eb java_util_AbstractCollection
// @dep_class f5238436362828db java_util_AbstractList
// @dep_class 58038509830ef3f4 java_util_ArrayList

// header file dependencies
// @dep_header gnu_java_security_der_DERReader
// @dep_header gnu_java_security_der_DERValue
// @dep_header gnu_java_security_der_DERWriter
// @dep_header gnu_java_security_provider_DSASignature
// @dep_header java_io_ByteArrayInputStream
// @dep_header java_io_ByteArrayOutputStream
// @dep_header java_io_IOException
// @dep_header java_lang_ArithmeticException
// @dep_header java_lang_Class
// @dep_header java_lang_String
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_math_BigInteger
// @dep_header java_security_InvalidAlgorithmParameterException
// @dep_header java_security_InvalidKeyException
// @dep_header java_security_InvalidParameterException
// @dep_header java_security_MessageDigest
// @dep_header java_security_NoSuchAlgorithmException
// @dep_header java_security_NoSuchProviderException
// @dep_header java_security_PrivateKey
// @dep_header java_security_PublicKey
// @dep_header java_security_SecureRandom
// @dep_header java_security_SignatureException
// @dep_header java_security_interfaces_DSAParams
// @dep_header java_security_interfaces_DSAPrivateKey
// @dep_header java_security_interfaces_DSAPublicKey
// @dep_header java_security_spec_AlgorithmParameterSpec
// @dep_header java_util_ArrayList

#include "jc_defs.h"

#include "gnu/java/security/der/DERReader.h"
#include "gnu/java/security/der/DERValue.h"
#include "gnu/java/security/der/DERWriter.h"
#include "gnu/java/security/provider/DSASignature.h"
#include "java/io/ByteArrayInputStream.h"
#include "java/io/ByteArrayOutputStream.h"
#include "java/io/IOException.h"
#include "java/lang/ArithmeticException.h"
#include "java/lang/Class.h"
#include "java/lang/String.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/math/BigInteger.h"
#include "java/security/InvalidAlgorithmParameterException.h"
#include "java/security/InvalidKeyException.h"
#include "java/security/InvalidParameterException.h"
#include "java/security/MessageDigest.h"
#include "java/security/NoSuchAlgorithmException.h"
#include "java/security/NoSuchProviderException.h"
#include "java/security/PrivateKey.h"
#include "java/security/PublicKey.h"
#include "java/security/SecureRandom.h"
#include "java/security/SignatureException.h"
#include "java/security/interfaces/DSAParams.h"
#include "java/security/interfaces/DSAPrivateKey.h"
#include "java/security/interfaces/DSAPublicKey.h"
#include "java/security/spec/AlgorithmParameterSpec.h"
#include "java/util/ArrayList.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private java.security.interfaces.DSAPublicKey publicKey
static _jc_field _jc_gnu_java_security_provider_DSASignature$field_info$publicKey = {
	.name=		"publicKey",
	.signature=	"Ljava/security/interfaces/DSAPublicKey;",
	.class=		&_jc_gnu_java_security_provider_DSASignature$type,
	.type=		&_jc_java_security_interfaces_DSAPublicKey$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSASignature$object, refs[-1].gnu_java_security_provider_DSASignature.publicKey),
};

// private java.security.interfaces.DSAPrivateKey privateKey
static _jc_field _jc_gnu_java_security_provider_DSASignature$field_info$privateKey = {
	.name=		"privateKey",
	.signature=	"Ljava/security/interfaces/DSAPrivateKey;",
	.class=		&_jc_gnu_java_security_provider_DSASignature$type,
	.type=		&_jc_java_security_interfaces_DSAPrivateKey$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSASignature$object, refs[-1].gnu_java_security_provider_DSASignature.privateKey),
};

// private java.security.MessageDigest digest
static _jc_field _jc_gnu_java_security_provider_DSASignature$field_info$digest = {
	.name=		"digest",
	.signature=	"Ljava/security/MessageDigest;",
	.class=		&_jc_gnu_java_security_provider_DSASignature$type,
	.type=		&_jc_java_security_MessageDigest$type,
	.access_flags=	_JC_ACC_PRIVATE,
	.offset=	_JC_OFFSETOF(_jc_gnu_java_security_provider_DSASignature$object, refs[-1].gnu_java_security_provider_DSASignature.digest),
};

// Fields
static _jc_field *const _jc_gnu_java_security_provider_DSASignature$fields[] = {
	&_jc_gnu_java_security_provider_DSASignature$field_info$digest,
	&_jc_gnu_java_security_provider_DSASignature$field_info$privateKey,
	&_jc_gnu_java_security_provider_DSASignature$field_info$publicKey
};

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, _init$52f4ad9f2989aeee);

void
_jc_gnu_java_security_provider_DSASignature$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;

	r0 = this;
	_JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom) = _JC_NULL;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	_JC_LINE_NUMBER(73);				// 0
	return;
}

//
// private void <init>(gnu.java.security.provider.DSASignature)
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$_init$53920fedf0fd8ee1[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$_init$53920fedf0fd8ee1[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$_init$53920fedf0fd8ee1[] = {
	&_jc_gnu_java_security_provider_DSASignature$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$_init$53920fedf0fd8ee1 = {
	.name=			"<init>",
	.signature=		"(Lgnu/java/security/provider/DSASignature;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$_init$53920fedf0fd8ee1,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$_init$53920fedf0fd8ee1,
	.signature_hash=	_JC_JLONG(0x53920fedf0fd8ee1),
	.access_flags=		_JC_ACC_PRIVATE,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$_init$53920fedf0fd8ee1,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$_init$53920fedf0fd8ee1
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, _init$53920fedf0fd8ee1);

void
_jc_gnu_java_security_provider_DSASignature$method$_init$53920fedf0fd8ee1(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_gnu_java_security_provider_DSASignature$object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_security_MessageDigest$object *r4;

	r0 = this;
	r1 = param0;
	_JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom) = _JC_NULL;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	_JC_LINE_NUMBER(259);				// 0
	r2 = _JC_REF_FIELD(env, r1, gnu_java_security_provider_DSASignature, publicKey);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey) = r2;
	_JC_LINE_NUMBER(260);				// 1
	r3 = _JC_REF_FIELD(env, r1, gnu_java_security_provider_DSASignature, privateKey);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey) = r3;
	_JC_LINE_NUMBER(261);				// 2
	r4 = _JC_REF_FIELD(env, r1, gnu_java_security_provider_DSASignature, digest);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = r4;
	_JC_LINE_NUMBER(262);				// 3
	return;
}

/************************************************************************
 *			     Instance methods				*
 ************************************************************************/

//
// public java.lang.Object clone()
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$clone$b75f2713d6705f70[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$clone$b75f2713d6705f70[] = { 
_JC_TYPE_REFERENCE };

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$clone$b75f2713d6705f70 = {
	.name=			"clone",
	.signature=		"()Ljava/lang/Object;",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$clone$b75f2713d6705f70,
	.signature_hash=	_JC_JLONG(0xb75f2713d6705f70),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.clone$b75f2713d6705f70) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$clone$b75f2713d6705f70
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, clone$b75f2713d6705f70);

_jc_java_lang_Object$object *
_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r1;
	struct _jc_object *r2;
	struct _jc_object *r3;
	struct _jc_java_security_MessageDigest$object *r4;

	r0 = this;
	_JC_LINE_NUMBER(253);				// 0
	r1 = _JC_NEW(env, gnu_java_security_provider_DSASignature);
	_JC_REF_FIELD(env, r1, java_security_SignatureSpi, appRandom) = _JC_NULL;
	_JC_REF_FIELD(env, r1, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	_JC_REF_FIELD(env, r1, gnu_java_security_provider_DSASignature, publicKey) = r2;
	r3 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	_JC_REF_FIELD(env, r1, gnu_java_security_provider_DSASignature, privateKey) = r3;
	r4 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_REF_FIELD(env, r1, gnu_java_security_provider_DSASignature, digest) = r4;
	return r1;
}

//
// public java.lang.Object engineGetParameter(java.lang.String) throws java.security.InvalidParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineGetParameter$c70713ab9f3f12d6[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineGetParameter$c70713ab9f3f12d6[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineGetParameter$c70713ab9f3f12d6[] = {
	&_jc_java_security_InvalidParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineGetParameter$c70713ab9f3f12d6[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineGetParameter$c70713ab9f3f12d6 = {
	.name=			"engineGetParameter",
	.signature=		"(Ljava/lang/String;)Ljava/lang/Object;",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineGetParameter$c70713ab9f3f12d6,
	.return_type=		&_jc_java_lang_Object$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineGetParameter$c70713ab9f3f12d6,
	.signature_hash=	_JC_JLONG(0xc70713ab9f3f12d6),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineGetParameter$c70713ab9f3f12d6) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineGetParameter$c70713ab9f3f12d6,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineGetParameter$c70713ab9f3f12d6
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineGetParameter$c70713ab9f3f12d6);

_jc_java_lang_Object$object *
_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_java_lang_String$object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_security_InvalidParameterException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(247);				// 0
	r2 = _JC_NEW(env, java_security_InvalidParameterException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);
}

//
// public void engineInitSign(java.security.PrivateKey) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$59481b5a8d200c34[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$engineInitSign$59481b5a8d200c34[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
	_JC_TRAP(&_jc_java_security_NoSuchProviderException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$59481b5a8d200c34[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$59481b5a8d200c34[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$59481b5a8d200c34[] = {
	&_jc_java_security_PrivateKey$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$59481b5a8d200c34 = {
	.name=			"engineInitSign",
	.signature=		"(Ljava/security/PrivateKey;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$59481b5a8d200c34,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$59481b5a8d200c34,
	.signature_hash=	_JC_JLONG(0x59481b5a8d200c34),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineInitSign$59481b5a8d200c34) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$59481b5a8d200c34,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$engineInitSign$59481b5a8d200c34,
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$59481b5a8d200c34
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineInitSign$59481b5a8d200c34);

void
_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *volatile r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_InvalidKeyException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *r7;
	struct _jc_java_security_MessageDigest$object *volatile r8;
	struct _jc_java_security_NoSuchProviderException$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$59481b5a8d200c34, &&label2, &&label3);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(102);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPrivateKey$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(103);				// 1
	r2 = r1;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey) = r2;
	goto label1;

label0:
	_JC_LINE_NUMBER(105);				// 2
	r3 = _JC_NEW(env, java_security_InvalidKeyException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label1:
	r8 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	if (r8 != _JC_NULL)
		goto label4;
	_JC_TRAP_REGION(catch, 1);
	r8 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$0501b2a6af823665, 0, _JC_STRING(env, "SHA1"), _JC_STRING(env, "GNU"));
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = r8;
	_JC_TRAP_REGION(catch, 2);
	goto label4;

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 2);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;

label4:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r8);
	_JC_LINE_NUMBER(108);				// 3
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void engineInitSign(java.security.PrivateKey, java.security.SecureRandom) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$82a2f1097d5847be[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$engineInitSign$82a2f1097d5847be[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
	_JC_TRAP(&_jc_java_security_NoSuchProviderException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$82a2f1097d5847be[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$82a2f1097d5847be[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$82a2f1097d5847be[] = {
	&_jc_java_security_PrivateKey$type,
	&_jc_java_security_SecureRandom$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$82a2f1097d5847be = {
	.name=			"engineInitSign",
	.signature=		"(Ljava/security/PrivateKey;Ljava/security/SecureRandom;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineInitSign$82a2f1097d5847be,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitSign$82a2f1097d5847be,
	.signature_hash=	_JC_JLONG(0x82a2f1097d5847be),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineInitSign$82a2f1097d5847be) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineInitSign$82a2f1097d5847be,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$engineInitSign$82a2f1097d5847be,
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitSign$82a2f1097d5847be
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineInitSign$82a2f1097d5847be);

void
_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0, _jc_java_security_SecureRandom$object *param1)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *volatile r0;
	struct _jc_object *r1;
	struct _jc_java_security_NoSuchProviderException$object *r10;
	struct _jc_java_security_SecureRandom$object *r2;
	struct _jc_object *r3;
	struct _jc_java_security_InvalidKeyException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_VMThrowable$object *r6;
	struct _jc_java_security_NoSuchAlgorithmException$object *r8;
	struct _jc_java_security_MessageDigest$object *volatile r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$82a2f1097d5847be, &&label2, &&label3);

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(114);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPrivateKey$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(115);				// 1
	r3 = r1;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey) = r3;
	goto label1;

label0:
	_JC_LINE_NUMBER(117);				// 2
	r4 = _JC_NEW(env, java_security_InvalidKeyException);
	r5 = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r5;
	_JC_THROW(env, r4);

label1:
	_JC_LINE_NUMBER(119);				// 3
	_JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom) = r2;
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	if (r9 != _JC_NULL)
		goto label4;
	_JC_TRAP_REGION(catch, 1);
	r9 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$0501b2a6af823665, 0, _JC_STRING(env, "SHA1"), _JC_STRING(env, "GNU"));
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = r9;
	_JC_TRAP_REGION(catch, 2);
	goto label4;

label2:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 2);
	r10 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;

label4:
	_JC_TRAP_REGION(catch, 2);
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r9);
	_JC_LINE_NUMBER(121);				// 4
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void engineInitVerify(java.security.PublicKey) throws java.security.InvalidKeyException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitVerify$1de7286f7aa81902[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$engineInitVerify$1de7286f7aa81902[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
	_JC_TRAP(&_jc_java_security_NoSuchProviderException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitVerify$1de7286f7aa81902[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineInitVerify$1de7286f7aa81902[] = {
	&_jc_java_security_InvalidKeyException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineInitVerify$1de7286f7aa81902[] = {
	&_jc_java_security_PublicKey$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineInitVerify$1de7286f7aa81902 = {
	.name=			"engineInitVerify",
	.signature=		"(Ljava/security/PublicKey;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineInitVerify$1de7286f7aa81902,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineInitVerify$1de7286f7aa81902,
	.signature_hash=	_JC_JLONG(0x1de7286f7aa81902),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineInitVerify$1de7286f7aa81902) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineInitVerify$1de7286f7aa81902,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$engineInitVerify$1de7286f7aa81902,
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineInitVerify$1de7286f7aa81902
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineInitVerify$1de7286f7aa81902);

void
_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *volatile r0;
	struct _jc_object *r1;
	struct _jc_object *r2;
	struct _jc_java_security_InvalidKeyException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r5;
	struct _jc_java_security_NoSuchAlgorithmException$object *r7;
	struct _jc_java_security_MessageDigest$object *volatile r8;
	struct _jc_java_security_NoSuchProviderException$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$engineInitVerify$1de7286f7aa81902, &&label2, &&label3);

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(92);				// 0
	z0 = _JC_INSTANCEOF(env, r1, &_jc_java_security_interfaces_DSAPublicKey$type);
	if (z0 == 0)
		goto label0;
	_JC_LINE_NUMBER(93);				// 1
	r2 = r1;
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey) = r2;
	goto label1;

label0:
	_JC_LINE_NUMBER(95);				// 2
	r3 = _JC_NEW(env, java_security_InvalidKeyException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label1:
	r8 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	if (r8 != _JC_NULL)
		goto label4;
	_JC_TRAP_REGION(catch, 1);
	r8 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$0501b2a6af823665, 0, _JC_STRING(env, "SHA1"), _JC_STRING(env, "GNU"));
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = r8;
	_JC_TRAP_REGION(catch, 2);
	goto label4;

label2:
	_JC_TRAP_REGION(catch, 2);
	r7 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	goto label4;

label3:
	_JC_TRAP_REGION(catch, 2);
	r9 = _JC_CAUGHT_EXCEPTION(env);
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;

label4:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r8);
	_JC_LINE_NUMBER(97);				// 3
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public void engineSetParameter(java.lang.String, java.lang.Object) throws java.security.InvalidParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$fe653a0781d38e86[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$fe653a0781d38e86[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$fe653a0781d38e86[] = {
	&_jc_java_security_InvalidParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$fe653a0781d38e86[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_Object$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$fe653a0781d38e86 = {
	.name=			"engineSetParameter",
	.signature=		"(Ljava/lang/String;Ljava/lang/Object;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$fe653a0781d38e86,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$fe653a0781d38e86,
	.signature_hash=	_JC_JLONG(0xfe653a0781d38e86),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSetParameter$fe653a0781d38e86) / sizeof(void *),
	.num_parameters=	2,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$fe653a0781d38e86,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$fe653a0781d38e86
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSetParameter$fe653a0781d38e86);

void
_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_java_lang_String$object *param0, _jc_java_lang_Object$object *param1)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_Object$object *r2;
	struct _jc_java_security_InvalidParameterException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	r0 = this;
	r1 = param0;
	r2 = param1;
	_JC_LINE_NUMBER(234);				// 0
	r3 = _JC_NEW(env, java_security_InvalidParameterException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);
}

//
// public void engineSetParameter(java.security.spec.AlgorithmParameterSpec) throws java.security.InvalidAlgorithmParameterException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$1b6a221a44e2a8cf[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$1b6a221a44e2a8cf[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$1b6a221a44e2a8cf[] = {
	&_jc_java_security_InvalidAlgorithmParameterException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$1b6a221a44e2a8cf[] = {
	&_jc_java_security_spec_AlgorithmParameterSpec$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$1b6a221a44e2a8cf = {
	.name=			"engineSetParameter",
	.signature=		"(Ljava/security/spec/AlgorithmParameterSpec;)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineSetParameter$1b6a221a44e2a8cf,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSetParameter$1b6a221a44e2a8cf,
	.signature_hash=	_JC_JLONG(0x1b6a221a44e2a8cf),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSetParameter$1b6a221a44e2a8cf) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSetParameter$1b6a221a44e2a8cf,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSetParameter$1b6a221a44e2a8cf
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSetParameter$1b6a221a44e2a8cf);

void
_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_object *param0)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_object *r1;
	struct _jc_java_security_InvalidParameterException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	r0 = this;
	r1 = param0;
	_JC_LINE_NUMBER(240);				// 0
	r2 = _JC_NEW(env, java_security_InvalidParameterException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);
}

//
// public byte[] engineSign() throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$ec82475ff8d6db66[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$engineSign$ec82475ff8d6db66[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
	_JC_TRAP(&_jc_java_lang_ArithmeticException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$ec82475ff8d6db66[] = { 
_JC_TYPE_REFERENCE };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$ec82475ff8d6db66[] = {
	&_jc_java_security_SignatureException$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSign$ec82475ff8d6db66 = {
	.name=			"engineSign",
	.signature=		"()[B",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_byte$array$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$ec82475ff8d6db66,
	.signature_hash=	_JC_JLONG(0xec82475ff8d6db66),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSign$ec82475ff8d6db66) / sizeof(void *),
	.num_parameters=	0,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$ec82475ff8d6db66,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$engineSign$ec82475ff8d6db66,
	  .u= {
	    .linenum= {
	      .len=	23,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$ec82475ff8d6db66
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSign$ec82475ff8d6db66);

_jc_byte_array *
_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_math_BigInteger$object *r1;
	struct _jc_java_security_SignatureException$object *volatile r10;
	struct _jc_object *r11;
	struct _jc_object *r12;
	struct _jc_java_security_SecureRandom$object *r13;
	struct _jc_gnu_java_security_der_DERValue$object *r14;
	struct _jc_java_io_IOException$object *r15;
	struct _jc_java_lang_ArithmeticException$object *r16;
	struct _jc_java_math_BigInteger$object *r17;
	struct _jc_java_lang_String$object *r18;
	struct _jc_java_lang_VMThrowable$object *r19;
	struct _jc_java_math_BigInteger$object *r2;
	struct _jc_java_lang_String$object *r20;
	struct _jc_java_lang_VMThrowable$object *r21;
	_jc_byte_array *r22;
	struct _jc_java_lang_String$object *volatile r23;
	struct _jc_java_lang_VMThrowable$object *volatile r24;
	struct _jc_java_lang_String$object *volatile r25;
	struct _jc_java_lang_VMThrowable$object *volatile r26;
	struct _jc_java_lang_Object$object *r27;
	_jc_object_array *r28;
	struct _jc_java_lang_Object$object *r29;
	struct _jc_java_math_BigInteger$object *r3;
	_jc_object_array *r30;
	_jc_object_array *r31;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	_jc_byte_array *r6;
	struct _jc_java_io_ByteArrayOutputStream$object *r7;
	struct _jc_java_util_ArrayList$object *r8;
	struct _jc_java_security_MessageDigest$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$engineSign$ec82475ff8d6db66, &&label2, &&label3);

	r0 = this;
	_JC_LINE_NUMBER(144);				// 0
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	if (r9 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(145);				// 1
	r10 = _JC_NEW(env, java_security_SignatureException);
	r18 = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r19 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r19;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r18;
	_JC_THROW(env, r10);

label0:
	_JC_LINE_NUMBER(146);				// 2
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	if (r11 != _JC_NULL)
		goto label1;
	_JC_LINE_NUMBER(147);				// 3
	r10 = _JC_NEW(env, java_security_SignatureException);
	r20 = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r21 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r21;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r20;
	_JC_THROW(env, r10);

label1:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(151);				// 4
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r12 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xcf8a9747be586d14), _jc_object *);
	r1 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *);
	_JC_LINE_NUMBER(152);				// 5
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r12 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xcf8a9747be586d14), _jc_object *);
	r2 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0x612c6062f1779963), _jc_object *);
	_JC_LINE_NUMBER(153);				// 6
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r12 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0xcf8a9747be586d14), _jc_object *);
	r3 = _JC_INVOKE_INTERFACE(env, r12, _JC_JLONG(0xe08c53541a87120d), _jc_object *);
	_JC_LINE_NUMBER(155);				// 7
	r11 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, privateKey);
	r4 = _JC_INVOKE_INTERFACE(env, r11, _JC_JLONG(0x568a3b7b0d38db21), _jc_object *);
	_JC_LINE_NUMBER(157);				// 8
	r5 = _JC_NEW(env, java_math_BigInteger);
	r13 = _JC_REF_FIELD(env, r0, java_security_SignatureSpi, appRandom);
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, bitCount) = -1;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, bitLength) = -1;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, firstNonzeroByteNum) = -2;
	_JC_PRIM_FIELD(env, r5, java_math_BigInteger, lowestSetBit) = -2;
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, init$883549c549a1f62e, 0, r5, 159, r13);
	_JC_LINE_NUMBER(159);				// 9
	r2 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r1, r5, r2);
	_JC_LINE_NUMBER(160);				// 10
	r1 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r2, r3);
	_JC_LINE_NUMBER(162);				// 11
	r9 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	r6 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, digest$24bbd103f8f0384e, r9);
	_JC_LINE_NUMBER(163);				// 12
	r2 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$85a20918701c98c3, 0, r2, 1, r6);
	_JC_LINE_NUMBER(165);				// 13
	r4 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r4, r1);
	r17 = _JC_INVOKE_STATIC(env, java_math_BigInteger, add$0f1977f0088adaa5, 1, r2, r4, 1);
	_JC_LINE_NUMBER(166);				// 14
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, modInverse$0a292348e6c1b6de, 0, r5, r3);
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r17, r5);
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r5, r3);
	_JC_LINE_NUMBER(168);				// 15
	r7 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	i0 = _JC_STATIC_FIELD(env, java_io_ByteArrayOutputStream, initial__5fbuffer__5fsize, 1);
	r22 = _JC_NEW_PRIM_ARRAY(env, byte, 1, i0);
	_JC_REF_FIELD(env, r7, java_io_ByteArrayOutputStream, buf) = r22;
	_JC_PRIM_FIELD(env, r7, java_io_ByteArrayOutputStream, count) = 0;
	_JC_LINE_NUMBER(169);				// 16
	r8 = _JC_NEW(env, java_util_ArrayList);
	r31 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 2);
	_JC_REF_FIELD(env, r8, java_util_ArrayList, data) = r31;
	_JC_LINE_NUMBER(170);				// 17
	r14 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r14, 2, 0, r1, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, checkBoundExclusive$dc2cb4673246a680, 0, r8, 0);
	r28 = _JC_REF_FIELD(env, r8, java_util_ArrayList, data);
	r27 = _JC_REF_ELEMENT(env, r28, 0, 0, 1);
	r28 = _JC_REF_FIELD(env, r8, java_util_ArrayList, data);
	_JC_ARRAYSTORE_CHECK(env, r28, r14);
	_JC_REF_ELEMENT(env, r28, 0, 0, 1) = r14;
	_JC_LINE_NUMBER(171);				// 18
	r14 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r14, 2, 0, r5, _JC_NULL);
	_JC_INVOKE_NONVIRTUAL(env, java_util_ArrayList, checkBoundExclusive$dc2cb4673246a680, 0, r8, 1);
	r30 = _JC_REF_FIELD(env, r8, java_util_ArrayList, data);
	r29 = _JC_REF_ELEMENT(env, r30, 1, 0, 1);
	r30 = _JC_REF_FIELD(env, r8, java_util_ArrayList, data);
	_JC_ARRAYSTORE_CHECK(env, r30, r14);
	_JC_REF_ELEMENT(env, r30, 1, 0, 1) = r14;
	_JC_LINE_NUMBER(172);				// 19
	r14 = _JC_NEW(env, gnu_java_security_der_DERValue);
	_JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERValue, _init$8e22e8011ae1da3a, 0, r14, 48, 0, r8, _JC_NULL);
	_JC_INVOKE_STATIC(env, gnu_java_security_der_DERWriter, write$dd9c0500806ff3af, 0, r7, r14);
	_JC_LINE_NUMBER(173);				// 20
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayOutputStream, toByteArray$3292ac9bfdd8d59a, 0, r7);
	_JC_TRAP_REGION(catch, 2);
	_JC_CANCEL_TRAPS(env, catch);
	return r6;

label2:
	_JC_TRAP_REGION(catch, 2);
	r15 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(175);				// 21
	r10 = _JC_NEW(env, java_security_SignatureException);
	r23 = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r24 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r24;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r23;
	_JC_THROW(env, r10);

label3:
	_JC_TRAP_REGION(catch, 2);
	r16 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(177);				// 22
	r10 = _JC_NEW(env, java_security_SignatureException);
	r25 = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r26 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r26;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r25;
	_JC_THROW(env, r10);
}

//
// public int engineSign(byte[], int, int) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$9742a7a61cf9f5b8[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$9742a7a61cf9f5b8[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_INT };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$9742a7a61cf9f5b8[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineSign$9742a7a61cf9f5b8[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineSign$9742a7a61cf9f5b8 = {
	.name=			"engineSign",
	.signature=		"([BII)I",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineSign$9742a7a61cf9f5b8,
	.return_type=		&_jc_int$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineSign$9742a7a61cf9f5b8,
	.signature_hash=	_JC_JLONG(0x9742a7a61cf9f5b8),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineSign$9742a7a61cf9f5b8) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineSign$9742a7a61cf9f5b8,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	5,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineSign$9742a7a61cf9f5b8
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineSign$9742a7a61cf9f5b8);

jint
_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	jint i2;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	_jc_byte_array *r1;
	_jc_byte_array *r2;
	struct _jc_java_security_SignatureException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(184);				// 0
	r2 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_provider_DSASignature, engineSign$ec82475ff8d6db66, r0);
	_JC_LINE_NUMBER(185);				// 1
	i2 = _JC_ARRAY_LENGTH(env, r2);
	if (i2 <= i1)
		goto label0;
	_JC_LINE_NUMBER(186);				// 2
	r3 = _JC_NEW(env, java_security_SignatureException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(187);				// 3
	i2 = _JC_ARRAY_LENGTH(env, r2);
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r2, 0, r1, i0, i2);
	_JC_LINE_NUMBER(188);				// 4
	i2 = _JC_ARRAY_LENGTH(env, r2);
	return i2;
}

//
// public void engineUpdate(byte) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$807e0421d3c3a314[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$807e0421d3c3a314[] = { 
_JC_TYPE_BYTE, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$807e0421d3c3a314[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$807e0421d3c3a314[] = {
	&_jc_byte$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$807e0421d3c3a314 = {
	.name=			"engineUpdate",
	.signature=		"(B)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$807e0421d3c3a314,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$807e0421d3c3a314,
	.signature_hash=	_JC_JLONG(0x807e0421d3c3a314),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineUpdate$807e0421d3c3a314) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$807e0421d3c3a314,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$807e0421d3c3a314
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineUpdate$807e0421d3c3a314);

void
_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, jbyte param0)
{
	jbyte b0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	struct _jc_java_security_MessageDigest$object *r1;
	struct _jc_java_security_SignatureException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_VMThrowable$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	b0 = param0;
	_JC_LINE_NUMBER(126);				// 0
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	if (r1 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(127);				// 1
	r2 = _JC_NEW(env, java_security_SignatureException);
	r3 = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	r5 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, vmState) = r5;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label0:
	_JC_LINE_NUMBER(129);				// 2
	r1 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, update$373bf0a44dde26ba, r1, b0);
	_JC_LINE_NUMBER(130);				// 3
	return;
}

//
// public void engineUpdate(byte[], int, int) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$d2f85b5d32010900[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$d2f85b5d32010900[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_INT, _JC_TYPE_INT, _JC_TYPE_VOID };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$d2f85b5d32010900[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$d2f85b5d32010900[] = {
	&_jc_byte$array$prim$type,
	&_jc_int$prim$type,
	&_jc_int$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$d2f85b5d32010900 = {
	.name=			"engineUpdate",
	.signature=		"([BII)V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineUpdate$d2f85b5d32010900,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineUpdate$d2f85b5d32010900,
	.signature_hash=	_JC_JLONG(0xd2f85b5d32010900),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineUpdate$d2f85b5d32010900) / sizeof(void *),
	.num_parameters=	3,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineUpdate$d2f85b5d32010900,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	4,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineUpdate$d2f85b5d32010900
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineUpdate$d2f85b5d32010900);

void
_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_byte_array *param0, jint param1, jint param2)
{
	jint i0;
	jint i1;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_security_MessageDigest$object *r2;
	struct _jc_java_security_SignatureException$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_VMThrowable$object *r6;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = this;
	r1 = param0;
	i0 = param1;
	i1 = param2;
	_JC_LINE_NUMBER(135);				// 0
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	if (r2 != _JC_NULL)
		goto label0;
	_JC_LINE_NUMBER(136);				// 1
	r3 = _JC_NEW(env, java_security_SignatureException);
	r4 = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, cause) = r3;
	r6 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r3);
	_JC_REF_FIELD(env, r3, java_lang_Throwable, vmState) = r6;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r3, java_lang_Throwable, detailMessage) = r4;
	_JC_THROW(env, r3);

label0:
	_JC_LINE_NUMBER(138);				// 2
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, update$f73f1b3bfa3ea853, r2, r1, i0, i1);
	_JC_LINE_NUMBER(139);				// 3
	return;
}

//
// public boolean engineVerify(byte[]) throws java.security.SignatureException
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$engineVerify$0a8a54ac81f3ea48[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$engineVerify$0a8a54ac81f3ea48[] = {
	_JC_TRAP(&_jc_java_io_IOException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$engineVerify$0a8a54ac81f3ea48[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_BOOLEAN };

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$exceptions$engineVerify$0a8a54ac81f3ea48[] = {
	&_jc_java_security_SignatureException$type
};

static _jc_type *const _jc_gnu_java_security_provider_DSASignature$param_types$engineVerify$0a8a54ac81f3ea48[] = {
	&_jc_byte$array$prim$type
};

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$engineVerify$0a8a54ac81f3ea48 = {
	.name=			"engineVerify",
	.signature=		"([B)Z",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.param_types=		&_jc_gnu_java_security_provider_DSASignature$param_types$engineVerify$0a8a54ac81f3ea48,
	.return_type=		&_jc_boolean$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$engineVerify$0a8a54ac81f3ea48,
	.signature_hash=	_JC_JLONG(0xa8a54ac81f3ea48),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.engineVerify$0a8a54ac81f3ea48) / sizeof(void *),
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_gnu_java_security_provider_DSASignature$exceptions$engineVerify$0a8a54ac81f3ea48,
	.u= { .exec= {
	  .trap_table_len=	1,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$engineVerify$0a8a54ac81f3ea48,
	  .u= {
	    .linenum= {
	      .len=	20,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$engineVerify$0a8a54ac81f3ea48
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, engineVerify$0a8a54ac81f3ea48);

jboolean
_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this, _jc_byte_array *param0)
{
	jint i0;
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;
	_jc_byte_array *r1;
	struct _jc_java_math_BigInteger$object *r10;
	struct _jc_java_security_SignatureException$object *volatile r11;
	struct _jc_java_lang_Object$object *r12;
	struct _jc_object *r13;
	struct _jc_object *r14;
	struct _jc_java_security_MessageDigest$object *r15;
	struct _jc_java_io_IOException$object *r16;
	struct _jc_java_lang_String$object *r17;
	struct _jc_java_lang_String$object *volatile r18;
	struct _jc_java_io_ByteArrayInputStream$object *r19;
	struct _jc_gnu_java_security_der_DERReader$object *r2;
	struct _jc_java_lang_VMThrowable$object *r20;
	struct _jc_java_lang_VMThrowable$object *volatile r21;
	struct _jc_java_io_ByteArrayOutputStream$object *r22;
	_jc_byte_array *r23;
	struct _jc_gnu_java_security_der_DERValue$object *r3;
	struct _jc_java_math_BigInteger$object *r4;
	struct _jc_java_math_BigInteger$object *r5;
	struct _jc_java_math_BigInteger$object *r6;
	struct _jc_java_math_BigInteger$object *r7;
	struct _jc_java_math_BigInteger$object *r8;
	struct _jc_java_math_BigInteger$object *r9;
	jboolean z0;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$engineVerify$0a8a54ac81f3ea48, &&label2);

	r0 = this;
	r1 = param0;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(196);				// 0
	r2 = _JC_NEW(env, gnu_java_security_der_DERReader);
	r19 = _JC_NEW(env, java_io_ByteArrayInputStream);
	i0 = _JC_ARRAY_LENGTH(env, r1);
	_JC_INVOKE_NONVIRTUAL(env, java_io_ByteArrayInputStream, _init$4ff4a7925ef7b06c, 0, r19, r1, 0, i0);
	_JC_REF_FIELD(env, r2, gnu_java_security_der_DERReader, in) = r19;
	r22 = _JC_NEW(env, java_io_ByteArrayOutputStream);
	r23 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r22, java_io_ByteArrayOutputStream, buf) = r23;
	_JC_PRIM_FIELD(env, r22, java_io_ByteArrayOutputStream, count) = 0;
	_JC_REF_FIELD(env, r2, gnu_java_security_der_DERReader, encBuf) = r22;
	_JC_LINE_NUMBER(197);				// 1
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	_JC_LINE_NUMBER(198);				// 2
	z0 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, isConstructed$a7f1dc7730ad5522, r3);
	if (z0 != 0)
		goto label0;
	_JC_LINE_NUMBER(199);				// 3
	r11 = _JC_NEW(env, java_security_SignatureException);
	r17 = _JC_STRING(env, "badly formed signature");
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r20 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r20;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r11);

label0:
	_JC_LINE_NUMBER(200);				// 4
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	r12 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r4 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r12);
	_JC_LINE_NUMBER(201);				// 5
	r3 = _JC_INVOKE_NONVIRTUAL(env, gnu_java_security_der_DERReader, read$97cabf4c92410204, 0, r2);
	r12 = _JC_INVOKE_VIRTUAL(env, gnu_java_security_der_DERValue, getValue$6f8b281a5ffcc94f, r3);
	r5 = _JC_CAST(env, &_jc_java_math_BigInteger$type, r12);
	_JC_LINE_NUMBER(203);				// 6
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r14 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xcf8a9747be586d14), _jc_object *);
	r6 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x59cffd735b56d8ad), _jc_object *);
	_JC_LINE_NUMBER(204);				// 7
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r14 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xcf8a9747be586d14), _jc_object *);
	r7 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0x612c6062f1779963), _jc_object *);
	_JC_LINE_NUMBER(205);				// 8
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r14 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xcf8a9747be586d14), _jc_object *);
	r8 = _JC_INVOKE_INTERFACE(env, r14, _JC_JLONG(0xe08c53541a87120d), _jc_object *);
	_JC_LINE_NUMBER(207);				// 9
	r13 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, publicKey);
	r9 = _JC_INVOKE_INTERFACE(env, r13, _JC_JLONG(0xe067a5f1fb934d2a), _jc_object *);
	_JC_LINE_NUMBER(209);				// 10
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modInverse$0a292348e6c1b6de, r5, r8);
	_JC_LINE_NUMBER(211);				// 11
	r15 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	r1 = _JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, digest$24bbd103f8f0384e, r15);
	_JC_LINE_NUMBER(212);				// 12
	r10 = _JC_NEW(env, java_math_BigInteger);
	_JC_INVOKE_NONVIRTUAL(env, java_math_BigInteger, _init$85a20918701c98c3, 0, r10, 1, r1);
	_JC_LINE_NUMBER(214);				// 13
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r5, r10);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r10, r8);
	_JC_LINE_NUMBER(216);				// 14
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r4, r5);
	r5 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r5, r8);
	_JC_LINE_NUMBER(219);				// 15
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r6, r10, r7);
	r9 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, modPow$53dfc6db09e99e77, r9, r5, r7);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, multiply$cbbaf53ac7ecf4eb, r10, r9);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r10, r7);
	r10 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, mod$c133bf571fc002f1, r10, r8);
	_JC_LINE_NUMBER(221);				// 16
	z0 = _JC_INVOKE_VIRTUAL(env, java_math_BigInteger, equals$8a15e0625571c581, r10, r4);
	if (z0 == 0)
		goto label1;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(222);				// 17
	_JC_CANCEL_TRAPS(env, catch);
	return 1;

label1:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(224);				// 18
	_JC_CANCEL_TRAPS(env, catch);
	return 0;

label2:
	_JC_TRAP_REGION(catch, 2);
	r16 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(226);				// 19
	r11 = _JC_NEW(env, java_security_SignatureException);
	r18 = _JC_STRING(env, "badly formed signature");
	_JC_REF_FIELD(env, r11, java_lang_Throwable, cause) = r11;
	r21 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r11);
	_JC_REF_FIELD(env, r11, java_lang_Throwable, vmState) = r21;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r11, java_lang_Throwable, detailMessage) = r18;
	_JC_THROW(env, r11);
}

//
// private final void init()
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$init$d82f2cc8ccf1c754[];

static _jc_trap_info _jc_gnu_java_security_provider_DSASignature$trap_table$init$d82f2cc8ccf1c754[] = {
	_JC_TRAP(&_jc_java_security_NoSuchAlgorithmException$type, 1, 2),
	_JC_TRAP(&_jc_java_security_NoSuchProviderException$type, 1, 2),
};

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$init$d82f2cc8ccf1c754[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$init$d82f2cc8ccf1c754 = {
	.name=			"init",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$init$d82f2cc8ccf1c754,
	.signature_hash=	_JC_JLONG(0xd82f2cc8ccf1c754),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$init$d82f2cc8ccf1c754,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.init$d82f2cc8ccf1c754) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .trap_table_len=	2,
	  .trap_table=		_jc_gnu_java_security_provider_DSASignature$trap_table$init$d82f2cc8ccf1c754,
	  .u= {
	    .linenum= {
	      .len=	6,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$init$d82f2cc8ccf1c754
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, init$d82f2cc8ccf1c754);

void
_jc_gnu_java_security_provider_DSASignature$method$init$d82f2cc8ccf1c754(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *volatile r0;
	struct _jc_java_security_NoSuchAlgorithmException$object *r1;
	struct _jc_java_security_MessageDigest$object *volatile r2;
	struct _jc_java_security_NoSuchProviderException$object *r5;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_gnu_java_security_provider_DSASignature$method_info$init$d82f2cc8ccf1c754, &&label0, &&label1);

	r0 = this;
	_JC_LINE_NUMBER(77);				// 0
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	if (r2 != _JC_NULL)
		goto label2;
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(79);				// 1
	r2 = _JC_INVOKE_STATIC(env, java_security_MessageDigest, getInstance$0501b2a6af823665, 0, _JC_STRING(env, "SHA1"), _JC_STRING(env, "GNU"));
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = r2;
	_JC_TRAP_REGION(catch, 2);
	goto label2;

label0:
	_JC_TRAP_REGION(catch, 2);
	r1 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(81);				// 2
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	goto label2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r5 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(83);				// 3
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;

label2:
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(86);				// 4
	r2 = _JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest);
	_JC_INVOKE_VIRTUAL(env, java_security_MessageDigest, reset$229a80b3e8394a0f, r2);
	_JC_LINE_NUMBER(87);				// 5
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// private final void this()
//

static _jc_linenum _jc_gnu_java_security_provider_DSASignature$linenum_table$this$adc93fb6bf4cbffa[];

static const unsigned char _jc_gnu_java_security_provider_DSASignature$param_ptypes$this$adc93fb6bf4cbffa[] = { 
_JC_TYPE_VOID };

_jc_method _jc_gnu_java_security_provider_DSASignature$method_info$this$adc93fb6bf4cbffa = {
	.name=			"this",
	.signature=		"()V",
	.class=			&_jc_gnu_java_security_provider_DSASignature$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_gnu_java_security_provider_DSASignature$param_ptypes$this$adc93fb6bf4cbffa,
	.signature_hash=	_JC_JLONG(0xadc93fb6bf4cbffa),
	.access_flags=		_JC_ACC_PRIVATE|_JC_ACC_FINAL,
	.function=		&_jc_gnu_java_security_provider_DSASignature$method$this$adc93fb6bf4cbffa,
	.vtable_index=		_JC_OFFSETOF(struct _jc_gnu_java_security_provider_DSASignature$vtable, gnu_java_security_provider_DSASignature.this$adc93fb6bf4cbffa) / sizeof(void *),
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_gnu_java_security_provider_DSASignature$linenum_table$this$adc93fb6bf4cbffa
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(gnu_java_security_provider_DSASignature, this$adc93fb6bf4cbffa);

void
_jc_gnu_java_security_provider_DSASignature$method$this$adc93fb6bf4cbffa(_jc_env *const env, _jc_gnu_java_security_provider_DSASignature$object *this)
{
	struct _jc_gnu_java_security_provider_DSASignature$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(70);				// 0
	_JC_REF_FIELD(env, r0, gnu_java_security_provider_DSASignature, digest) = _JC_NULL;
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_gnu_java_security_provider_DSASignature$methods[] = {
	&_jc_gnu_java_security_provider_DSASignature$method_info$_init$52f4ad9f2989aeee,
	&_jc_gnu_java_security_provider_DSASignature$method_info$_init$53920fedf0fd8ee1,
	&_jc_gnu_java_security_provider_DSASignature$method_info$clone$b75f2713d6705f70,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineGetParameter$c70713ab9f3f12d6,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$59481b5a8d200c34,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineInitSign$82a2f1097d5847be,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineInitVerify$1de7286f7aa81902,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$fe653a0781d38e86,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSetParameter$1b6a221a44e2a8cf,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSign$ec82475ff8d6db66,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineSign$9742a7a61cf9f5b8,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$807e0421d3c3a314,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineUpdate$d2f85b5d32010900,
	&_jc_gnu_java_security_provider_DSASignature$method_info$engineVerify$0a8a54ac81f3ea48,
	&_jc_gnu_java_security_provider_DSASignature$method_info$init$d82f2cc8ccf1c754,
	&_jc_gnu_java_security_provider_DSASignature$method_info$this$adc93fb6bf4cbffa
};

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_10[] = {
	&_jc_gnu_java_security_provider_DSASignature$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_110[] = {
	&_jc_java_security_SignatureSpi$type,
	_JC_NULL
};
static _jc_type *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_113[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_gnu_java_security_provider_DSASignature$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[10]=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_10,
	[110]=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_110,
	[113]=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_bucket_113
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_gnu_java_security_provider_DSASignature$class_depends[] = {
	{ "gnu/java/security/der/DERReader",	_JC_JLONG(0x72b2c34b8fa2f145) },
	{ "gnu/java/security/der/DERValue",	_JC_JLONG(0x6370ccdc23537458) },
	{ "gnu/java/security/der/DERWriter",	_JC_JLONG(0x87aa78f6a77ed8b) },
	{ "java/io/ByteArrayInputStream",	_JC_JLONG(0xa68cc27886fd8be3) },
	{ "java/io/ByteArrayOutputStream",	_JC_JLONG(0xc4d3cc2bda03a338) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/OutputStream",	_JC_JLONG(0x4026d3144d6654d8) },
	{ "java/lang/ArithmeticException",	_JC_JLONG(0x42020e4665019671) },
	{ "java/lang/Class",	_JC_JLONG(0xbf29ff960d5ec1d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/Number",	_JC_JLONG(0x9cd7252f79299280) },
	{ "java/lang/Object",	_JC_JLONG(0x2a7152deee1944f1) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc80f4aedd95be265) },
	{ "java/lang/System",	_JC_JLONG(0xa0a8fafccf4b2db9) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/math/BigInteger",	_JC_JLONG(0x7717ded55c30b7f3) },
	{ "java/security/GeneralSecurityException",	_JC_JLONG(0x692089051f4c8d0b) },
	{ "java/security/InvalidAlgorithmParameterException",	_JC_JLONG(0x327edce29f2562dd) },
	{ "java/security/InvalidKeyException",	_JC_JLONG(0x94dda41e9bf6c170) },
	{ "java/security/InvalidParameterException",	_JC_JLONG(0x99827f89c0c36c1) },
	{ "java/security/KeyException",	_JC_JLONG(0x965d036f0f33fac6) },
	{ "java/security/MessageDigest",	_JC_JLONG(0xcc2047cad8dcf75e) },
	{ "java/security/NoSuchAlgorithmException",	_JC_JLONG(0x22e937c2536160b4) },
	{ "java/security/NoSuchProviderException",	_JC_JLONG(0x8dfbf242adab91e) },
	{ "java/security/PrivateKey",	_JC_JLONG(0xdcdbe4a102f59043) },
	{ "java/security/PublicKey",	_JC_JLONG(0x4db3ac05e70e2bf8) },
	{ "java/security/SecureRandom",	_JC_JLONG(0x15c6a62b25a6e96d) },
	{ "java/security/SignatureException",	_JC_JLONG(0x7ce2f2d523fa52ac) },
	{ "java/security/SignatureSpi",	_JC_JLONG(0x15e444274ebb7a6e) },
	{ "java/security/interfaces/DSAParams",	_JC_JLONG(0xf4f2d6013f72861e) },
	{ "java/security/interfaces/DSAPrivateKey",	_JC_JLONG(0xd57e7f1f963e5163) },
	{ "java/security/interfaces/DSAPublicKey",	_JC_JLONG(0xbad97fafc9653a27) },
	{ "java/security/spec/AlgorithmParameterSpec",	_JC_JLONG(0xef2e5e8af121478f) },
	{ "java/util/AbstractCollection",	_JC_JLONG(0x8ea716c64b77f8eb) },
	{ "java/util/AbstractList",	_JC_JLONG(0xf5238436362828db) },
	{ "java/util/ArrayList",	_JC_JLONG(0x58038509830ef3f4) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_gnu_java_security_provider_DSASignature$vtype _jc_gnu_java_security_provider_DSASignature$type = {
    .type= {
	.name=			"gnu/java/security/provider/DSASignature",
	.superclass=		&_jc_java_security_SignatureSpi$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		39,
		.hash=			_JC_JLONG(0x3a4d5790dae5ac8a),
		.source_file=		"DSASignature.java",
		.instance_size=		sizeof(_jc_gnu_java_security_provider_DSASignature$refs) + sizeof(_jc_gnu_java_security_provider_DSASignature$object),
		.num_virtual_refs=	4,
		.num_fields=		sizeof(_jc_gnu_java_security_provider_DSASignature$fields) / sizeof(*_jc_gnu_java_security_provider_DSASignature$fields),
		.fields=		_jc_gnu_java_security_provider_DSASignature$fields,
		.num_methods=		sizeof(_jc_gnu_java_security_provider_DSASignature$methods) / sizeof(*_jc_gnu_java_security_provider_DSASignature$methods),
		.methods=		_jc_gnu_java_security_provider_DSASignature$methods,
		.instanceof_hash_table=	_jc_gnu_java_security_provider_DSASignature$instanceof_hash_table,
		.num_class_depends=		sizeof(_jc_gnu_java_security_provider_DSASignature$class_depends) / sizeof(*_jc_gnu_java_security_provider_DSASignature$class_depends),
		.class_depends=		_jc_gnu_java_security_provider_DSASignature$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.java_security_SignatureSpi= {
	    .clone$b75f2713d6705f70=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	    .engineGetParameter$c70713ab9f3f12d6=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6,
	    .engineGetParameters$4feb0e256d9d7317=
		&_jc_java_security_SignatureSpi$method$engineGetParameters$4feb0e256d9d7317,
	    .engineInitSign$59481b5a8d200c34=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34,
	    .engineInitSign$82a2f1097d5847be=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be,
	    .engineInitVerify$1de7286f7aa81902=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902,
	    .engineSetParameter$fe653a0781d38e86=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86,
	    .engineSetParameter$1b6a221a44e2a8cf=		// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf,
	    .engineSign$ec82475ff8d6db66=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66,
	    .engineSign$9742a7a61cf9f5b8=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8,
	    .engineUpdate$807e0421d3c3a314=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314,
	    .engineUpdate$d2f85b5d32010900=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900,
	    .engineVerify$0a8a54ac81f3ea48=			// overridden
		&_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48,
	    .engineVerify$faa9b7bfcc2ddd84=
		&_jc_java_security_SignatureSpi$method$engineVerify$faa9b7bfcc2ddd84,
	},
	.gnu_java_security_provider_DSASignature= {
	    .clone$b75f2713d6705f70=
		&_jc_gnu_java_security_provider_DSASignature$method$clone$b75f2713d6705f70,
	    .engineGetParameter$c70713ab9f3f12d6=
		&_jc_gnu_java_security_provider_DSASignature$method$engineGetParameter$c70713ab9f3f12d6,
	    .engineInitSign$59481b5a8d200c34=
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$59481b5a8d200c34,
	    .engineInitSign$82a2f1097d5847be=
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitSign$82a2f1097d5847be,
	    .engineInitVerify$1de7286f7aa81902=
		&_jc_gnu_java_security_provider_DSASignature$method$engineInitVerify$1de7286f7aa81902,
	    .engineSetParameter$fe653a0781d38e86=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$fe653a0781d38e86,
	    .engineSetParameter$1b6a221a44e2a8cf=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSetParameter$1b6a221a44e2a8cf,
	    .engineSign$ec82475ff8d6db66=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$ec82475ff8d6db66,
	    .engineSign$9742a7a61cf9f5b8=
		&_jc_gnu_java_security_provider_DSASignature$method$engineSign$9742a7a61cf9f5b8,
	    .engineUpdate$807e0421d3c3a314=
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$807e0421d3c3a314,
	    .engineUpdate$d2f85b5d32010900=
		&_jc_gnu_java_security_provider_DSASignature$method$engineUpdate$d2f85b5d32010900,
	    .engineVerify$0a8a54ac81f3ea48=
		&_jc_gnu_java_security_provider_DSASignature$method$engineVerify$0a8a54ac81f3ea48,
	    .init$d82f2cc8ccf1c754=
		&_jc_gnu_java_security_provider_DSASignature$method$init$d82f2cc8ccf1c754,
	    .this$adc93fb6bf4cbffa=
		&_jc_gnu_java_security_provider_DSASignature$method$this$adc93fb6bf4cbffa,
	},
    }
};

