// public class soot.jimple.parser.Parse

// class file dependencies
// @dep_class 3b9ab84c09eb9794 gnu_java_io_EncodingManager
// @dep_class 870660487dad1b68 gnu_java_io_decode_Decoder
// @dep_class 4090b3611aacb15c java_io_BufferedInputStream
// @dep_class 2f32f9b77402a730 java_io_BufferedReader
// @dep_class 9cef6b66128b04b2 java_io_File
// @dep_class 7be583f744423388 java_io_FileInputStream
// @dep_class 411c07e717eacf69 java_io_FileNotFoundException
// @dep_class 455accfa535f5dfe java_io_FilterInputStream
// @dep_class cd1b0cd67de1a4a8 java_io_FilterReader
// @dep_class 4e0a56550c69d57c java_io_IOException
// @dep_class 66aea4d152614ac4 java_io_InputStream
// @dep_class f5b355df85c1991d java_io_InputStreamReader
// @dep_class 75f014535cd80b2e java_io_PrintStream
// @dep_class 256b8854df68a74 java_io_PushbackReader
// @dep_class 688afb20bd4c4e01 java_io_Reader
// @dep_class bf29ff960d5ec1d0 java_lang_Class
// @dep_class 308333d803f5ab9f java_lang_Error
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 505b8a9a6675be0 java_lang_NullPointerException
// @dep_class 2a7152deee1944f1 java_lang_Object
// @dep_class f05d2f2f0c04795d java_lang_Runtime
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class c80f4aedd95be265 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class a0a8fafccf4b2db9 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 2d9140403cf61244 java_lang_reflect_Constructor
// @dep_class d7cd853200c3e71f java_util_HashMap
// @dep_class b6d33af8f84fdbc4 soot_G
// @dep_class 7120c8047949f8c0 soot_Scene
// @dep_class 6ac5bee50bbabb71 soot_Singletons
// @dep_class 634bd13ff2d8ac70 soot_SootClass
// @dep_class b4f2fa22d2f10a73 soot_SootResolver
// @dep_class 72cded5f00a3b1f0 soot_jimple_parser_BodyExtractorWalker
// @dep_class 93b64c99340fb1e8 soot_jimple_parser_Parse
// @dep_class b8af2571138d5c8f soot_jimple_parser_Walker
// @dep_class eda4e769c2cb49b3 soot_jimple_parser_analysis_Analysis
// @dep_class 8dfca5174d48db80 soot_jimple_parser_lexer_Lexer
// @dep_class d4ec105ca792f934 soot_jimple_parser_lexer_LexerException
// @dep_class 8367d01c238d6542 soot_jimple_parser_node_Start
// @dep_class 5aaa49c2b1c7a032 soot_jimple_parser_parser_Parser
// @dep_class 350479636530ccb1 soot_jimple_parser_parser_ParserException
// @dep_class d340ba1fc04730c0 soot_util_EscapedReader

// header file dependencies
// @dep_header gnu_java_io_EncodingManager
// @dep_header gnu_java_io_decode_Decoder
// @dep_header java_io_BufferedInputStream
// @dep_header java_io_BufferedReader
// @dep_header java_io_File
// @dep_header java_io_FileInputStream
// @dep_header java_io_FileNotFoundException
// @dep_header java_io_InputStreamReader
// @dep_header java_io_PrintStream
// @dep_header java_io_PushbackReader
// @dep_header java_lang_Class
// @dep_header java_lang_Error
// @dep_header java_lang_NullPointerException
// @dep_header java_lang_Runtime
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_System
// @dep_header java_lang_VMThrowable
// @dep_header java_lang_reflect_Constructor
// @dep_header java_util_HashMap
// @dep_header soot_G
// @dep_header soot_Scene
// @dep_header soot_SootClass
// @dep_header soot_SootResolver
// @dep_header soot_jimple_parser_BodyExtractorWalker
// @dep_header soot_jimple_parser_Parse
// @dep_header soot_jimple_parser_analysis_Analysis
// @dep_header soot_jimple_parser_lexer_Lexer
// @dep_header soot_jimple_parser_lexer_LexerException
// @dep_header soot_jimple_parser_node_Start
// @dep_header soot_jimple_parser_parser_Parser
// @dep_header soot_jimple_parser_parser_ParserException
// @dep_header soot_util_EscapedReader

#include "jc_defs.h"

#include "gnu/java/io/EncodingManager.h"
#include "gnu/java/io/decode/Decoder.h"
#include "java/io/BufferedInputStream.h"
#include "java/io/BufferedReader.h"
#include "java/io/File.h"
#include "java/io/FileInputStream.h"
#include "java/io/FileNotFoundException.h"
#include "java/io/InputStreamReader.h"
#include "java/io/PrintStream.h"
#include "java/io/PushbackReader.h"
#include "java/lang/Class.h"
#include "java/lang/Error.h"
#include "java/lang/NullPointerException.h"
#include "java/lang/Runtime.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/System.h"
#include "java/lang/VMThrowable.h"
#include "java/lang/reflect/Constructor.h"
#include "java/util/HashMap.h"
#include "soot/G.h"
#include "soot/Scene.h"
#include "soot/SootClass.h"
#include "soot/SootResolver.h"
#include "soot/jimple/parser/BodyExtractorWalker.h"
#include "soot/jimple/parser/Parse.h"
#include "soot/jimple/parser/analysis/Analysis.h"
#include "soot/jimple/parser/lexer/Lexer.h"
#include "soot/jimple/parser/lexer/LexerException.h"
#include "soot/jimple/parser/node/Start.h"
#include "soot/jimple/parser/parser/Parser.h"
#include "soot/jimple/parser/parser/ParserException.h"
#include "soot/util/EscapedReader.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// private static final java.lang.String EXT
static _jc_field _jc_soot_jimple_parser_Parse$field_info$EXT = {
	.name=		"EXT",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_soot_jimple_parser_Parse$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_parser_Parse$fields_struct, EXT),
	.initial_value=	".jimple",
};

// private static final java.lang.String USAGE
static _jc_field _jc_soot_jimple_parser_Parse$field_info$USAGE = {
	.name=		"USAGE",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_soot_jimple_parser_Parse$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PRIVATE|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_soot_jimple_parser_Parse$fields_struct, USAGE),
	.initial_value=	"usage: java Parse [options] jimple_file [jimple_file ...]",
};

// Fields
static _jc_field *const _jc_soot_jimple_parser_Parse$fields[] = {
	&_jc_soot_jimple_parser_Parse$field_info$EXT,
	&_jc_soot_jimple_parser_Parse$field_info$USAGE
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// public static void main(java.lang.String[]) throws java.lang.Exception
//

static _jc_linenum _jc_soot_jimple_parser_Parse$linenum_table$main$bc98a92695db8a73[];

static _jc_trap_info _jc_soot_jimple_parser_Parse$trap_table$main$bc98a92695db8a73[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 5, 6),
	_JC_TRAP(&_jc_java_io_FileNotFoundException$type, 1, 2),
	_JC_TRAP(&_jc_java_io_FileNotFoundException$type, 3, 4),
};

static const unsigned char _jc_soot_jimple_parser_Parse$param_ptypes$main$bc98a92695db8a73[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_VOID };

static _jc_type *const _jc_soot_jimple_parser_Parse$exceptions$main$bc98a92695db8a73[] = {
	&_jc_java_lang_Exception$type
};

static _jc_type *const _jc_soot_jimple_parser_Parse$param_types$main$bc98a92695db8a73[] = {
	&_jc_java_lang_String$array$type
};

_jc_method _jc_soot_jimple_parser_Parse$method_info$main$bc98a92695db8a73 = {
	.name=			"main",
	.signature=		"([Ljava/lang/String;)V",
	.class=			&_jc_soot_jimple_parser_Parse$type,
	.param_types=		&_jc_soot_jimple_parser_Parse$param_types$main$bc98a92695db8a73,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_parser_Parse$param_ptypes$main$bc98a92695db8a73,
	.signature_hash=	_JC_JLONG(0xbc98a92695db8a73),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_jimple_parser_Parse$method$main$bc98a92695db8a73,
	.num_parameters=	1,
	.num_exceptions=	1,
	.exceptions=		&_jc_soot_jimple_parser_Parse$exceptions$main$bc98a92695db8a73,
	.u= { .exec= {
	  .trap_table_len=	3,
	  .trap_table=		_jc_soot_jimple_parser_Parse$trap_table$main$bc98a92695db8a73,
	  .u= {
	    .linenum= {
	      .len=	30,
	      .table=	_jc_soot_jimple_parser_Parse$linenum_table$main$bc98a92695db8a73
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_parser_Parse, main$bc98a92695db8a73);

void
_jc_soot_jimple_parser_Parse$method$main$bc98a92695db8a73(_jc_env *const env, _jc_object_array *param0)
{
	jint volatile i0;
	jint volatile i1;
	jint volatile i2;
	jint volatile i3;
	jint volatile i4;
	jint volatile i5;
	jint volatile i6;
	_jc_object_array *volatile r0;
	struct _jc_java_lang_String$object *volatile r1;
	struct _jc_soot_jimple_parser_parser_Parser$object *volatile r10;
	struct _jc_soot_jimple_parser_lexer_Lexer$object *volatile r11;
	struct _jc_java_io_PushbackReader$object *volatile r12;
	struct _jc_soot_jimple_parser_node_Start$object *volatile r13;
	struct _jc_soot_jimple_parser_Walker$object *volatile r14;
	struct _jc_soot_G$object *r15;
	struct _jc_soot_G$object *volatile r16;
	struct _jc_soot_G$object *volatile r17;
	struct _jc_soot_G$object *volatile r18;
	struct _jc_soot_G$object *volatile r19;
	struct _jc_java_io_InputStream$object *volatile r2;
	struct _jc_java_lang_Runtime$object *r20;
	struct _jc_soot_Scene$object *r21;
	struct _jc_soot_G$object *r22;
	struct _jc_java_lang_String$object *volatile r23;
	struct _jc_java_lang_String$object *volatile r24;
	struct _jc_java_lang_String$object *volatile r25;
	struct _jc_java_lang_String$object *volatile r26;
	struct _jc_java_lang_String$object *volatile r27;
	struct _jc_java_lang_String$object *volatile r28;
	struct _jc_java_lang_String$object *volatile r29;
	struct _jc_java_io_FileNotFoundException$object *r3;
	struct _jc_object *volatile r30;
	_jc_char_array *volatile r31;
	struct _jc_java_io_File$object *volatile r32;
	struct _jc_java_lang_String$object *volatile r33;
	_jc_char_array *volatile r34;
	_jc_char_array *volatile r35;
	_jc_char_array *volatile r36;
	struct _jc_java_io_File$object *volatile r37;
	struct _jc_java_lang_String$object *volatile r38;
	_jc_char_array *volatile r39;
	struct _jc_java_io_InputStreamReader$object *volatile r4;
	struct _jc_java_lang_String$object *volatile r40;
	_jc_char_array *volatile r41;
	struct _jc_java_lang_Object$object *volatile r42;
	struct _jc_java_lang_NullPointerException$object *volatile r43;
	struct _jc_java_lang_String$object *volatile r44;
	struct _jc_java_lang_String$object *volatile r45;
	struct _jc_java_lang_VMThrowable$object *volatile r46;
	_jc_object_array *volatile r47;
	struct _jc_java_lang_reflect_Constructor$object *volatile r48;
	struct _jc_gnu_java_io_decode_Decoder$object *volatile r49;
	struct _jc_java_io_PrintStream$object *volatile r5;
	struct _jc_java_lang_Exception$object *volatile r50;
	struct _jc_java_lang_Error$object *volatile r51;
	struct _jc_java_lang_String$object *volatile r52;
	struct _jc_java_lang_Class$object *volatile r53;
	struct _jc_java_lang_Object$object *volatile r54;
	struct _jc_java_lang_VMThrowable$object *volatile r55;
	_jc_byte_array *volatile r56;
	struct _jc_java_lang_StringBuffer$object *volatile r6;
	struct _jc_java_io_FileInputStream$object *volatile r7;
	struct _jc_java_io_FileNotFoundException$object *r8;
	struct _jc_java_io_BufferedInputStream$object *volatile r9;
	jboolean volatile z0;
	jboolean volatile z1;
	jboolean volatile z2;
	jboolean volatile z3;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_soot_jimple_parser_Parse$method_info$main$bc98a92695db8a73, &&label11, &&label5, &&label8);

	r0 = param0;
	_JC_LINE_NUMBER(91);				// 0
	z0 = 0;
	_JC_LINE_NUMBER(95);				// 1
	i0 = _JC_ARRAY_LENGTH(env, r0);
	if (i0 >= 1)
		goto label0;
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(96);				// 2
	r15 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_REF_FIELD(env, r15, soot_G, out);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r5, _JC_STRING(env, "usage: java Parse [options] jimple_file [jimple_file ...]"));
	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_ACTIVE_USE(env, java_lang_Runtime);
	r20 = _JC_STATIC_FIELD(env, java_lang_Runtime, current, 1);
	_JC_INVOKE_VIRTUAL(env, java_lang_Runtime, exit$84287cac76c5d2ef, r20, 0);

label0:
	_JC_ACTIVE_USE(env, soot_Scene);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(101);				// 3
	r22 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r21 = _JC_INVOKE_VIRTUAL(env, soot_Singletons, Scene$3451207662ac1af0, r22);
	_JC_INVOKE_VIRTUAL(env, soot_Scene, setPhantomRefs$7468e71ea45713a2, r21, 1);
	_JC_LINE_NUMBER(103);				// 4
	i0 = 0;

label1:
	_JC_TRAP_REGION(catch, 0);
	i1 = _JC_ARRAY_LENGTH(env, r0);
	if (i0 >= i1)
		goto label14;
	_JC_LINE_NUMBER(104);				// 5
	r1 = _JC_REF_ELEMENT(env, r0, i0, 1, 0);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r23 = _JC_STRING(env, "-");
	i2 = _JC_PRIM_FIELD(env, r23, java_lang_String, count);
	z2 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, regionMatches$8a82c88118b60ee6, 0, r1, 0, 0, r23, 0, i2);
	_JC_LINE_NUMBER(105);				// 6
	if (z2 == 0)
		goto label3;
	i3 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	r24 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r1, 1, i3);
	_JC_LINE_NUMBER(107);				// 7
	z1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 1, r24, _JC_STRING(env, "d"));
	if (z1 == 0)
		goto label2;
	_JC_LINE_NUMBER(108);				// 8
	goto label13;

label2:
	_JC_LINE_NUMBER(109);				// 9
	z1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, equals$8a15e0625571c581, 0, r24, _JC_STRING(env, "v"));
	if (z1 == 0)
		goto label13;
	_JC_LINE_NUMBER(110);				// 10
	z0 = 1;
	goto label13;

label3:
	_JC_TRAP_REGION(catch, 1);
	_JC_LINE_NUMBER(116);				// 11
	if (z0 == 0)
		goto label4;
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(117);				// 12
	r16 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_REF_FIELD(env, r16, soot_G, out);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r31 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r31;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " ... looking for "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r25 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r25, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r5, r25);

label4:
	_JC_LINE_NUMBER(118);				// 13
	r7 = _JC_NEW(env, java_io_FileInputStream);
	r32 = _JC_NEW(env, java_io_File);
	r33 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r32, r1);
	_JC_REF_FIELD(env, r32, java_io_File, path) = r33;
	_JC_INVOKE_NONVIRTUAL(env, java_io_FileInputStream, _init$538ee07130435a5e, 0, r7, r32);
	r2 = r7;
	_JC_TRAP_REGION(catch, 2);
	_JC_LINE_NUMBER(133);				// 14
	goto label9;

label5:
	_JC_TRAP_REGION(catch, 2);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	r40 = _JC_STRING(env, ".jimple");
	i4 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	i5 = _JC_PRIM_FIELD(env, r40, java_lang_String, count);
	i5 = i4 - i5;
	i4 = _JC_PRIM_FIELD(env, r40, java_lang_String, count);
	z3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, regionMatches$8a82c88118b60ee6, 0, r1, 0, i5, r40, 0, i4);
	_JC_LINE_NUMBER(120);				// 15
	if (z3 == 0)
		goto label6;
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(121);				// 16
	r17 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_REF_FIELD(env, r17, soot_G, out);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r34 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r34;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " *** can't find "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r26 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r26, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r5, r26);
	_JC_LINE_NUMBER(122);				// 17
	goto label13;

label6:
	_JC_LINE_NUMBER(124);				// 18
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r35 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r35;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r1);
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, ".jimple"));
	r27 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r27, r6);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(126);				// 19
	if (z0 == 0)
		goto label7;
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(127);				// 20
	r18 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_REF_FIELD(env, r18, soot_G, out);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r36 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r36;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " ... looking for "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r27);
	r28 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r28, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r5, r28);

label7:
	_JC_LINE_NUMBER(128);				// 21
	r9 = _JC_NEW(env, java_io_BufferedInputStream);
	r7 = _JC_NEW(env, java_io_FileInputStream);
	r37 = _JC_NEW(env, java_io_File);
	r38 = _JC_INVOKE_NONVIRTUAL(env, java_io_File, normalizePath$c82ffbd1adfcec00, 0, r37, r27);
	_JC_REF_FIELD(env, r37, java_io_File, path) = r38;
	_JC_INVOKE_NONVIRTUAL(env, java_io_FileInputStream, _init$538ee07130435a5e, 0, r7, r37);
	_JC_REF_FIELD(env, r9, java_io_FilterInputStream, in) = r7;
	_JC_PRIM_FIELD(env, r9, java_io_BufferedInputStream, markpos) = -1;
	r56 = _JC_NEW_PRIM_ARRAY(env, byte, 1, 2048);
	_JC_REF_FIELD(env, r9, java_io_BufferedInputStream, buf) = r56;
	_JC_PRIM_FIELD(env, r9, java_io_BufferedInputStream, bufferSize) = 2048;
	_JC_PRIM_FIELD(env, r9, java_io_BufferedInputStream, count) = 2048;
	_JC_PRIM_FIELD(env, r9, java_io_BufferedInputStream, pos) = 2048;
	r2 = r9;
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(132);				// 22
	goto label9;

label8:
	_JC_TRAP_REGION(catch, 4);
	r3 = _JC_CAUGHT_EXCEPTION(env);
	_JC_ACTIVE_USE(env, soot_G);
	_JC_LINE_NUMBER(130);				// 23
	r19 = _JC_STATIC_FIELD(env, soot_G, instance, 1);
	r5 = _JC_REF_FIELD(env, r19, soot_G, out);
	r6 = _JC_NEW(env, java_lang_StringBuffer);
	r39 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r6, java_lang_StringBuffer, value) = r39;
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, _JC_STRING(env, " *** can't find "));
	r6 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r6, r27);
	r29 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r29, r6);
	_JC_INVOKE_VIRTUAL(env, java_io_PrintStream, println$f7dbc2aa0f0a9d4f, r5, r29);
	_JC_LINE_NUMBER(131);				// 24
	goto label13;

label9:
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(135);				// 25
	r10 = _JC_NEW(env, soot_jimple_parser_parser_Parser);
	r11 = _JC_NEW(env, soot_jimple_parser_lexer_Lexer);
	r12 = _JC_NEW(env, java_io_PushbackReader);
	r4 = _JC_NEW(env, java_io_InputStreamReader);
	_JC_REF_FIELD(env, r4, java_io_Reader, lock) = r4;
	if (r2 != _JC_NULL)
		goto label10;
	r43 = _JC_NEW(env, java_lang_NullPointerException);
	r45 = _JC_NULL;
	_JC_REF_FIELD(env, r43, java_lang_Throwable, cause) = r43;
	r46 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r43);
	_JC_REF_FIELD(env, r43, java_lang_Throwable, vmState) = r46;
	_JC_REF_FIELD(env, r43, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r43, java_lang_Throwable, detailMessage) = r45;
	_JC_THROW(env, r43);

label10:
	_JC_ACTIVE_USE(env, gnu_java_io_EncodingManager);
	_JC_TRAP_REGION(catch, 5);
	r47 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 1);
	_JC_ARRAYSTORE_CHECK(env, r47, r2);
	_JC_REF_ELEMENT(env, r47, 0, 0, 0) = r2;
	r48 = _JC_STATIC_FIELD(env, gnu_java_io_EncodingManager, default__5fdecoder__5fcons, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r48);
	r53 = _JC_REF_FIELD(env, r48, java_lang_reflect_Constructor, clazz);
	i6 = _JC_PRIM_FIELD(env, r48, java_lang_reflect_Constructor, slot);
	r54 = _JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_Constructor, constructNative$ab0a21e35464145a, 0, r48, r47, r53, i6);
	r49 = _JC_CAST(env, &_jc_gnu_java_io_decode_Decoder$type, r54);
	_JC_TRAP_REGION(catch, 6);
	goto label12;

label11:
	_JC_TRAP_REGION(catch, 6);
	r50 = _JC_CAUGHT_EXCEPTION(env);
	r51 = _JC_NEW(env, java_lang_Error);
	r52 = _JC_STRING(env, "Unexpected problems with default decoder");
	_JC_REF_FIELD(env, r51, java_lang_Throwable, cause) = r51;
	r55 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r51);
	_JC_REF_FIELD(env, r51, java_lang_Throwable, vmState) = r55;
	_JC_REF_FIELD(env, r51, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r51, java_lang_Throwable, detailMessage) = r52;
	_JC_REF_FIELD(env, r51, java_lang_Throwable, cause) = r50;
	_JC_THROW(env, r51);

label12:
	r44 = _JC_INVOKE_VIRTUAL(env, gnu_java_io_decode_Decoder, getSchemeName$4ee238e7a3fd99b3, r49);
	_JC_REF_FIELD(env, r4, java_io_InputStreamReader, encoding) = r44;
	_JC_REF_FIELD(env, r4, java_io_InputStreamReader, in) = r49;
	r42 = _JC_REF_FIELD(env, r4, java_io_Reader, lock);
	_JC_REF_FIELD(env, r12, java_io_Reader, lock) = r42;
	_JC_REF_FIELD(env, r12, java_io_FilterReader, in) = r4;
	r41 = _JC_NEW_PRIM_ARRAY(env, char, 1, 1024);
	_JC_REF_FIELD(env, r12, java_io_PushbackReader, buf) = r41;
	_JC_PRIM_FIELD(env, r12, java_io_PushbackReader, pos) = 1024;
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_lexer_Lexer, _init$64b82f12dc95990a, 0, r11, r12);
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_parser_Parser, _init$c0ddcd2e393ed366, 0, r10, r11);
	_JC_LINE_NUMBER(141);				// 26
	r13 = _JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_parser_Parser, parse$e55fd473e44fa846, 0, r10);
	_JC_LINE_NUMBER(143);				// 27
	r14 = _JC_NEW(env, soot_jimple_parser_Walker);
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_Walker, _init$f960fbcab686639c, 0, r14, _JC_NULL);
	_JC_EXPLICIT_NULL_CHECK(env, r13);
	r30 = r14;
	_JC_INVOKE_INTERFACE(env, r30, _JC_JLONG(0x54431c76f01c85df), void, r13);

label13:
	_JC_TRAP_REGION(catch, 6);
	_JC_LINE_NUMBER(103);				// 28
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label1;

label14:
	_JC_TRAP_REGION(catch, 6);
	_JC_LINE_NUMBER(146);				// 29
	_JC_CANCEL_TRAPS(env, catch);
	return;
}

//
// public static soot.SootClass parse(java.io.InputStream, soot.SootClass)
//

static _jc_linenum _jc_soot_jimple_parser_Parse$linenum_table$parse$35f8024c06bf1039[];

static _jc_trap_info _jc_soot_jimple_parser_Parse$trap_table$parse$35f8024c06bf1039[] = {
	_JC_TRAP(&_jc_java_lang_Exception$type, 1, 2),
	_JC_TRAP(&_jc_soot_jimple_parser_parser_ParserException$type, 3, 4),
	_JC_TRAP(&_jc_soot_jimple_parser_lexer_LexerException$type, 3, 4),
	_JC_TRAP(&_jc_java_io_IOException$type, 3, 4),
};

static const unsigned char _jc_soot_jimple_parser_Parse$param_ptypes$parse$35f8024c06bf1039[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_jimple_parser_Parse$param_types$parse$35f8024c06bf1039[] = {
	&_jc_java_io_InputStream$type,
	&_jc_soot_SootClass$type
};

_jc_method _jc_soot_jimple_parser_Parse$method_info$parse$35f8024c06bf1039 = {
	.name=			"parse",
	.signature=		"(Ljava/io/InputStream;Lsoot/SootClass;)Lsoot/SootClass;",
	.class=			&_jc_soot_jimple_parser_Parse$type,
	.param_types=		&_jc_soot_jimple_parser_Parse$param_types$parse$35f8024c06bf1039,
	.return_type=		&_jc_soot_SootClass$type,
	.param_ptypes=		&_jc_soot_jimple_parser_Parse$param_ptypes$parse$35f8024c06bf1039,
	.signature_hash=	_JC_JLONG(0x35f8024c06bf1039),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_jimple_parser_Parse$method$parse$35f8024c06bf1039,
	.num_parameters=	2,
	.u= { .exec= {
	  .trap_table_len=	4,
	  .trap_table=		_jc_soot_jimple_parser_Parse$trap_table$parse$35f8024c06bf1039,
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_soot_jimple_parser_Parse$linenum_table$parse$35f8024c06bf1039
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_parser_Parse, parse$35f8024c06bf1039);

_jc_soot_SootClass$object *
_jc_soot_jimple_parser_Parse$method$parse$35f8024c06bf1039(_jc_env *const env, _jc_java_io_InputStream$object *param0, _jc_soot_SootClass$object *param1)
{
	jint i0;
	struct _jc_java_io_InputStream$object *r0;
	struct _jc_soot_SootClass$object *r1;
	struct _jc_java_lang_RuntimeException$object *volatile r10;
	struct _jc_java_lang_StringBuffer$object *volatile r11;
	struct _jc_soot_jimple_parser_lexer_LexerException$object *volatile r12;
	struct _jc_java_io_IOException$object *volatile r13;
	struct _jc_soot_jimple_parser_Walker$object *r14;
	struct _jc_soot_jimple_parser_BodyExtractorWalker$object *r15;
	struct _jc_java_util_HashMap$object *r16;
	struct _jc_java_lang_String$object *volatile r17;
	struct _jc_java_lang_String$object *volatile r18;
	struct _jc_java_lang_String$object *volatile r19;
	struct _jc_soot_jimple_parser_lexer_Lexer$object *r2;
	struct _jc_soot_SootResolver$object *r20;
	struct _jc_object *r21;
	_jc_char_array *volatile r22;
	_jc_char_array *volatile r23;
	_jc_char_array *volatile r24;
	struct _jc_java_lang_VMThrowable$object *volatile r25;
	struct _jc_java_lang_VMThrowable$object *volatile r26;
	struct _jc_java_lang_VMThrowable$object *volatile r27;
	struct _jc_java_lang_StringBuffer$object *r28;
	struct _jc_java_lang_Object$object *r29;
	struct _jc_java_io_PushbackReader$object *r3;
	_jc_char_array *r30;
	struct _jc_java_lang_StringBuffer$object *volatile r31;
	struct _jc_java_lang_String$object *volatile r32;
	struct _jc_java_lang_StringBuffer$object *volatile r33;
	struct _jc_java_lang_String$object *volatile r34;
	struct _jc_java_lang_StringBuffer$object *volatile r35;
	struct _jc_java_lang_String$object *volatile r36;
	_jc_char_array *r37;
	struct _jc_java_lang_Object$object *r38;
	struct _jc_java_lang_NullPointerException$object *r39;
	struct _jc_soot_util_EscapedReader$object *r4;
	struct _jc_java_lang_String$object *r40;
	struct _jc_java_lang_String$object *r41;
	struct _jc_java_lang_VMThrowable$object *r42;
	_jc_object_array *r43;
	struct _jc_java_lang_reflect_Constructor$object *r44;
	struct _jc_gnu_java_io_decode_Decoder$object *r45;
	struct _jc_java_lang_Exception$object *volatile r46;
	struct _jc_java_lang_Error$object *volatile r47;
	struct _jc_java_lang_String$object *volatile r48;
	struct _jc_java_lang_Class$object *r49;
	struct _jc_java_io_BufferedReader$object *r5;
	struct _jc_java_lang_Object$object *r50;
	struct _jc_java_io_InputStreamReader$object *r6;
	struct _jc_soot_jimple_parser_parser_Parser$object *r7;
	struct _jc_soot_jimple_parser_parser_ParserException$object *volatile r8;
	struct _jc_soot_jimple_parser_node_Start$object *r9;
	_jc_catch_frame	catch;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	// Define exception targets
	_JC_DEFINE_TRAPS(env, catch, &_jc_soot_jimple_parser_Parse$method_info$parse$35f8024c06bf1039, &&label1, &&label3, &&label6, &&label9);

	r0 = param0;
	r1 = param1;
	_JC_LINE_NUMBER(58);				// 0
	r7 = _JC_NEW(env, soot_jimple_parser_parser_Parser);
	r2 = _JC_NEW(env, soot_jimple_parser_lexer_Lexer);
	r3 = _JC_NEW(env, java_io_PushbackReader);
	r4 = _JC_NEW(env, soot_util_EscapedReader);
	r5 = _JC_NEW(env, java_io_BufferedReader);
	r6 = _JC_NEW(env, java_io_InputStreamReader);
	_JC_REF_FIELD(env, r6, java_io_Reader, lock) = r6;
	if (r0 != _JC_NULL)
		goto label0;
	r39 = _JC_NEW(env, java_lang_NullPointerException);
	r41 = _JC_NULL;
	_JC_REF_FIELD(env, r39, java_lang_Throwable, cause) = r39;
	r42 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r39);
	_JC_REF_FIELD(env, r39, java_lang_Throwable, vmState) = r42;
	_JC_REF_FIELD(env, r39, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r39, java_lang_Throwable, detailMessage) = r41;
	_JC_THROW(env, r39);

label0:
	_JC_ACTIVE_USE(env, gnu_java_io_EncodingManager);
	_JC_TRAP_REGION(catch, 1);
	r43 = _JC_NEW_REF_ARRAY(env, java_lang_Object, 1, 1);
	_JC_ARRAYSTORE_CHECK(env, r43, r0);
	_JC_REF_ELEMENT(env, r43, 0, 0, 0) = r0;
	r44 = _JC_STATIC_FIELD(env, gnu_java_io_EncodingManager, default__5fdecoder__5fcons, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r44);
	r49 = _JC_REF_FIELD(env, r44, java_lang_reflect_Constructor, clazz);
	i0 = _JC_PRIM_FIELD(env, r44, java_lang_reflect_Constructor, slot);
	r50 = _JC_INVOKE_NONVIRTUAL(env, java_lang_reflect_Constructor, constructNative$ab0a21e35464145a, 0, r44, r43, r49, i0);
	r45 = _JC_CAST(env, &_jc_gnu_java_io_decode_Decoder$type, r50);
	_JC_TRAP_REGION(catch, 2);
	goto label2;

label1:
	_JC_TRAP_REGION(catch, 2);
	r46 = _JC_CAUGHT_EXCEPTION(env);
	r47 = _JC_NEW(env, java_lang_Error);
	r48 = _JC_STRING(env, "Unexpected problems with default decoder");
	_JC_REF_FIELD(env, r47, java_lang_Throwable, cause) = r47;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r47);
	_JC_REF_FIELD(env, r47, java_lang_Throwable, detailMessage) = r48;
	_JC_REF_FIELD(env, r47, java_lang_Throwable, cause) = r46;
	_JC_THROW(env, r47);

label2:
	r40 = _JC_INVOKE_VIRTUAL(env, gnu_java_io_decode_Decoder, getSchemeName$4ee238e7a3fd99b3, r45);
	_JC_REF_FIELD(env, r6, java_io_InputStreamReader, encoding) = r40;
	_JC_REF_FIELD(env, r6, java_io_InputStreamReader, in) = r45;
	_JC_INVOKE_NONVIRTUAL(env, java_io_BufferedReader, _init$92676f6e85ad07a2, 0, r5, r6, 8192);
	r29 = _JC_REF_FIELD(env, r5, java_io_Reader, lock);
	_JC_REF_FIELD(env, r4, java_io_Reader, lock) = r29;
	_JC_REF_FIELD(env, r4, java_io_FilterReader, in) = r5;
	r28 = _JC_NEW(env, java_lang_StringBuffer);
	r30 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r28, java_lang_StringBuffer, value) = r30;
	_JC_REF_FIELD(env, r4, soot_util_EscapedReader, mini) = r28;
	_JC_PRIM_FIELD(env, r4, soot_util_EscapedReader, nextch) = 0;
	r38 = _JC_REF_FIELD(env, r4, java_io_Reader, lock);
	_JC_REF_FIELD(env, r3, java_io_Reader, lock) = r38;
	_JC_REF_FIELD(env, r3, java_io_FilterReader, in) = r4;
	r37 = _JC_NEW_PRIM_ARRAY(env, char, 1, 1024);
	_JC_REF_FIELD(env, r3, java_io_PushbackReader, buf) = r37;
	_JC_PRIM_FIELD(env, r3, java_io_PushbackReader, pos) = 1024;
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_lexer_Lexer, _init$64b82f12dc95990a, 0, r2, r3);
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_parser_Parser, _init$c0ddcd2e393ed366, 0, r7, r2);
	_JC_TRAP_REGION(catch, 3);
	_JC_LINE_NUMBER(64);				// 1
	r9 = _JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_parser_Parser, parse$e55fd473e44fa846, 0, r7);
	_JC_TRAP_REGION(catch, 4);
	_JC_LINE_NUMBER(71);				// 2
	goto label12;

label3:
	_JC_TRAP_REGION(catch, 4);
	r8 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(66);				// 3
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r11 = _JC_NEW(env, java_lang_StringBuffer);
	r22 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r11, java_lang_StringBuffer, value) = r22;
	r11 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r11, _JC_STRING(env, "Parser exception occurred: "));
	r31 = r11;
	if (r8 != _JC_NULL)
		goto label4;
	r32 = _JC_STRING(env, "null");
	goto label5;

label4:
	r32 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r8);

label5:
	r31 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r31, r32);
	r17 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r17, r31);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r25 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r25;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r17;
	_JC_THROW(env, r10);

label6:
	_JC_TRAP_REGION(catch, 4);
	r12 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(68);				// 4
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r11 = _JC_NEW(env, java_lang_StringBuffer);
	r23 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r11, java_lang_StringBuffer, value) = r23;
	r11 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r11, _JC_STRING(env, "Lexer exception occurred: "));
	r33 = r11;
	if (r12 != _JC_NULL)
		goto label7;
	r34 = _JC_STRING(env, "null");
	goto label8;

label7:
	r34 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r12);

label8:
	r33 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r33, r34);
	r18 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r18, r33);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r26 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r26;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r18;
	_JC_THROW(env, r10);

label9:
	_JC_TRAP_REGION(catch, 4);
	r13 = _JC_CAUGHT_EXCEPTION(env);
	_JC_LINE_NUMBER(70);				// 5
	r10 = _JC_NEW(env, java_lang_RuntimeException);
	r11 = _JC_NEW(env, java_lang_StringBuffer);
	r24 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r11, java_lang_StringBuffer, value) = r24;
	r11 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r11, _JC_STRING(env, "IOException occurred: "));
	r35 = r11;
	if (r13 != _JC_NULL)
		goto label10;
	r36 = _JC_STRING(env, "null");
	goto label11;

label10:
	r36 = _JC_INVOKE_VIRTUAL(env, java_lang_Object, toString$7ea43b33b80a3070, r13);

label11:
	r35 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r35, r36);
	r19 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r19, r35);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r27 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r27;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r19;
	_JC_THROW(env, r10);

label12:
	_JC_LINE_NUMBER(74);				// 6
	if (r1 != _JC_NULL)
		goto label13;
	_JC_LINE_NUMBER(75);				// 7
	r14 = _JC_NEW(env, soot_jimple_parser_Walker);
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_Walker, _init$f960fbcab686639c, 0, r14, _JC_NULL);
	goto label14;

label13:
	_JC_LINE_NUMBER(77);				// 8
	r15 = _JC_NEW(env, soot_jimple_parser_BodyExtractorWalker);
	r16 = _JC_NEW(env, java_util_HashMap);
	_JC_INVOKE_NONVIRTUAL(env, java_util_HashMap, _init$7cb044ce4fb0ada8, 0, r16, 11, _JC_FCONST(0x3f, 0x40, 0x0, 0x0));
	r20 = _JC_NULL;
	_JC_INVOKE_NONVIRTUAL(env, soot_jimple_parser_Walker, _init$85e990391bb19b89, 0, r15, r1, r20);
	_JC_REF_FIELD(env, r15, soot_jimple_parser_BodyExtractorWalker, methodToParsedBodyMap) = r16;
	r14 = r15;

label14:
	_JC_EXPLICIT_NULL_CHECK(env, r9);
	r21 = r14;
	_JC_INVOKE_INTERFACE(env, r21, _JC_JLONG(0x54431c76f01c85df), void, r9);
	_JC_LINE_NUMBER(81);				// 9
	r1 = _JC_INVOKE_VIRTUAL(env, soot_jimple_parser_Walker, getSootClass$b30aad7b58a80a93, r14);
	_JC_CANCEL_TRAPS(env, catch);
	return r1;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_soot_jimple_parser_Parse$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_soot_jimple_parser_Parse$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_jimple_parser_Parse$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_soot_jimple_parser_Parse$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_jimple_parser_Parse$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_jimple_parser_Parse$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_jimple_parser_Parse$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_jimple_parser_Parse, _init$52f4ad9f2989aeee);

void
_jc_soot_jimple_parser_Parse$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_soot_jimple_parser_Parse$object *this)
{
	struct _jc_soot_jimple_parser_Parse$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(40);				// 0
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_jimple_parser_Parse$methods[] = {
	&_jc_soot_jimple_parser_Parse$method_info$_init$52f4ad9f2989aeee,
	&_jc_soot_jimple_parser_Parse$method_info$main$bc98a92695db8a73,
	&_jc_soot_jimple_parser_Parse$method_info$parse$35f8024c06bf1039
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_soot_jimple_parser_Parse$fields_struct _jc_soot_jimple_parser_Parse$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_jimple_parser_Parse$instanceof_hash_bucket_104[] = {
	&_jc_soot_jimple_parser_Parse$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_jimple_parser_Parse$instanceof_hash_bucket_113[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_jimple_parser_Parse$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[104]=	_jc_soot_jimple_parser_Parse$instanceof_hash_bucket_104,
	[113]=	_jc_soot_jimple_parser_Parse$instanceof_hash_bucket_113
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_jimple_parser_Parse$class_depends[] = {
	{ "gnu/java/io/EncodingManager",	_JC_JLONG(0x3b9ab84c09eb9794) },
	{ "gnu/java/io/decode/Decoder",	_JC_JLONG(0x870660487dad1b68) },
	{ "java/io/BufferedInputStream",	_JC_JLONG(0x4090b3611aacb15c) },
	{ "java/io/BufferedReader",	_JC_JLONG(0x2f32f9b77402a730) },
	{ "java/io/File",	_JC_JLONG(0x9cef6b66128b04b2) },
	{ "java/io/FileInputStream",	_JC_JLONG(0x7be583f744423388) },
	{ "java/io/FileNotFoundException",	_JC_JLONG(0x411c07e717eacf69) },
	{ "java/io/FilterInputStream",	_JC_JLONG(0x455accfa535f5dfe) },
	{ "java/io/FilterReader",	_JC_JLONG(0xcd1b0cd67de1a4a8) },
	{ "java/io/IOException",	_JC_JLONG(0x4e0a56550c69d57c) },
	{ "java/io/InputStream",	_JC_JLONG(0x66aea4d152614ac4) },
	{ "java/io/InputStreamReader",	_JC_JLONG(0xf5b355df85c1991d) },
	{ "java/io/PrintStream",	_JC_JLONG(0x75f014535cd80b2e) },
	{ "java/io/PushbackReader",	_JC_JLONG(0x256b8854df68a74) },
	{ "java/io/Reader",	_JC_JLONG(0x688afb20bd4c4e01) },
	{ "java/lang/Class",	_JC_JLONG(0xbf29ff960d5ec1d0) },
	{ "java/lang/Error",	_JC_JLONG(0x308333d803f5ab9f) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/NullPointerException",	_JC_JLONG(0x505b8a9a6675be0) },
	{ "java/lang/Object",	_JC_JLONG(0x2a7152deee1944f1) },
	{ "java/lang/Runtime",	_JC_JLONG(0xf05d2f2f0c04795d) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/String",	_JC_JLONG(0xc80f4aedd95be265) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/System",	_JC_JLONG(0xa0a8fafccf4b2db9) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/lang/reflect/Constructor",	_JC_JLONG(0x2d9140403cf61244) },
	{ "java/util/HashMap",	_JC_JLONG(0xd7cd853200c3e71f) },
	{ "soot/G",	_JC_JLONG(0xb6d33af8f84fdbc4) },
	{ "soot/Scene",	_JC_JLONG(0x7120c8047949f8c0) },
	{ "soot/Singletons",	_JC_JLONG(0x6ac5bee50bbabb71) },
	{ "soot/SootClass",	_JC_JLONG(0x634bd13ff2d8ac70) },
	{ "soot/SootResolver",	_JC_JLONG(0xb4f2fa22d2f10a73) },
	{ "soot/jimple/parser/BodyExtractorWalker",	_JC_JLONG(0x72cded5f00a3b1f0) },
	{ "soot/jimple/parser/Walker",	_JC_JLONG(0xb8af2571138d5c8f) },
	{ "soot/jimple/parser/analysis/Analysis",	_JC_JLONG(0xeda4e769c2cb49b3) },
	{ "soot/jimple/parser/lexer/Lexer",	_JC_JLONG(0x8dfca5174d48db80) },
	{ "soot/jimple/parser/lexer/LexerException",	_JC_JLONG(0xd4ec105ca792f934) },
	{ "soot/jimple/parser/node/Start",	_JC_JLONG(0x8367d01c238d6542) },
	{ "soot/jimple/parser/parser/Parser",	_JC_JLONG(0x5aaa49c2b1c7a032) },
	{ "soot/jimple/parser/parser/ParserException",	_JC_JLONG(0x350479636530ccb1) },
	{ "soot/util/EscapedReader",	_JC_JLONG(0xd340ba1fc04730c0) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_jimple_parser_Parse$vtype _jc_soot_jimple_parser_Parse$type = {
    .type= {
	.name=			"soot/jimple/parser/Parse",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		11,
		.hash=			_JC_JLONG(0x93b64c99340fb1e8),
		.source_file=		"Parse.java",
		.instance_size=		sizeof(_jc_soot_jimple_parser_Parse$refs) + sizeof(_jc_soot_jimple_parser_Parse$object),
		.num_virtual_refs=	0,
		.num_fields=		sizeof(_jc_soot_jimple_parser_Parse$fields) / sizeof(*_jc_soot_jimple_parser_Parse$fields),
		.fields=		_jc_soot_jimple_parser_Parse$fields,
		.num_methods=		sizeof(_jc_soot_jimple_parser_Parse$methods) / sizeof(*_jc_soot_jimple_parser_Parse$methods),
		.methods=		_jc_soot_jimple_parser_Parse$methods,
		.instanceof_hash_table=	_jc_soot_jimple_parser_Parse$instanceof_hash_table,
		.class_fields=		&_jc_soot_jimple_parser_Parse$class_fields,
		.num_class_depends=		sizeof(_jc_soot_jimple_parser_Parse$class_depends) / sizeof(*_jc_soot_jimple_parser_Parse$class_depends),
		.class_depends=		_jc_soot_jimple_parser_Parse$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_jimple_parser_Parse= {
	},
    }
};

