// public class soot.util.StringTools

// class file dependencies
// @dep_class c3e37402f8a0600b gnu_classpath_SystemProperties
// @dep_class bf29ff960d5ec1d0 java_lang_Class
// @dep_class c5feb325780a6cd7 java_lang_Exception
// @dep_class 680cf34d05feb5a1 java_lang_IllegalArgumentException
// @dep_class 3cdfed1e0ad1a3d6 java_lang_IndexOutOfBoundsException
// @dep_class 41f43e69651f01be java_lang_Integer
// @dep_class 2a7152deee1944f1 java_lang_Object
// @dep_class 4f5534a987354d1d java_lang_RuntimeException
// @dep_class d38282f3d5f80887 java_lang_SecurityManager
// @dep_class c80f4aedd95be265 java_lang_String
// @dep_class 94d357637b968dda java_lang_StringBuffer
// @dep_class bb7f6fdd2bd0e6b2 java_lang_StringIndexOutOfBoundsException
// @dep_class a0a8fafccf4b2db9 java_lang_System
// @dep_class 3be5c3c4fdd59a1e java_lang_Throwable
// @dep_class 4d1cebae0bdda058 java_lang_VMSystem
// @dep_class c8d6a6ffc5c1acc1 java_lang_VMThrowable
// @dep_class 297bcc893ad53f24 java_text_StringCharacterIterator
// @dep_class 884c3edb343dfb63 java_util_Properties
// @dep_class 8e89953898085705 soot_util_StringTools

// header file dependencies
// @dep_header gnu_classpath_SystemProperties
// @dep_header java_lang_Class
// @dep_header java_lang_IllegalArgumentException
// @dep_header java_lang_Integer
// @dep_header java_lang_SecurityManager
// @dep_header java_lang_String
// @dep_header java_lang_StringBuffer
// @dep_header java_lang_StringIndexOutOfBoundsException
// @dep_header java_lang_System
// @dep_header java_lang_VMSystem
// @dep_header java_lang_VMThrowable
// @dep_header java_text_StringCharacterIterator
// @dep_header java_util_Properties
// @dep_header soot_util_StringTools

#include "jc_defs.h"

#include "gnu/classpath/SystemProperties.h"
#include "java/lang/Class.h"
#include "java/lang/IllegalArgumentException.h"
#include "java/lang/Integer.h"
#include "java/lang/SecurityManager.h"
#include "java/lang/String.h"
#include "java/lang/StringBuffer.h"
#include "java/lang/StringIndexOutOfBoundsException.h"
#include "java/lang/System.h"
#include "java/lang/VMSystem.h"
#include "java/lang/VMThrowable.h"
#include "java/text/StringCharacterIterator.h"
#include "java/util/Properties.h"
#include "soot/util/StringTools.h"

/************************************************************************
 *				  Fields				*
 ************************************************************************/

// public static final java.lang.String lineSeparator
static _jc_field _jc_soot_util_StringTools$field_info$lineSeparator = {
	.name=		"lineSeparator",
	.signature=	"Ljava/lang/String;",
	.class=		&_jc_soot_util_StringTools$type,
	.type=		&_jc_java_lang_String$type,
	.access_flags=	_JC_ACC_PUBLIC|_JC_ACC_STATIC|_JC_ACC_FINAL,
	.offset=	_JC_OFFSETOF(_jc_soot_util_StringTools$fields_struct, lineSeparator),
};

// Fields
static _jc_field *const _jc_soot_util_StringTools$fields[] = {
	&_jc_soot_util_StringTools$field_info$lineSeparator
};

/************************************************************************
 *			      Static methods				*
 ************************************************************************/

//
// static void <clinit>()
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$_clinit$a816641e0ba8bfef[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$_clinit$a816641e0ba8bfef[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_util_StringTools$method_info$_clinit$a816641e0ba8bfef = {
	.name=			"<clinit>",
	.signature=		"()V",
	.class=			&_jc_soot_util_StringTools$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$_clinit$a816641e0ba8bfef,
	.signature_hash=	_JC_JLONG(0xa816641e0ba8bfef),
	.access_flags=		_JC_ACC_STATIC,
	.function=		&_jc_soot_util_StringTools$method$_clinit$a816641e0ba8bfef,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_util_StringTools$linenum_table$_clinit$a816641e0ba8bfef
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, _clinit$a816641e0ba8bfef);

void
_jc_soot_util_StringTools$method$_clinit$a816641e0ba8bfef(_jc_env *const env)
{
	jint i0;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_SecurityManager$object *r1;
	struct _jc_java_lang_IllegalArgumentException$object *r2;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_util_Properties$object *r5;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	_JC_ACTIVE_USE(env, java_lang_System);
	_JC_LINE_NUMBER(76);				// 0
	r0 = _JC_STRING(env, "line.separator");
	r1 = _JC_STATIC_FIELD(env, java_lang_SecurityManager, current, 0);
	if (r1 == _JC_NULL)
		goto label0;
	_JC_INVOKE_VIRTUAL(env, java_lang_SecurityManager, checkPropertyAccess$96b5133fb2013064, r1, r0);
	goto label1;

label0:
	i0 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	if (i0 != 0)
		goto label1;
	r2 = _JC_NEW(env, java_lang_IllegalArgumentException);
	r3 = _JC_STRING(env, "key can't be empty");
	_JC_REF_FIELD(env, r2, java_lang_Throwable, cause) = r2;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_Throwable, fillInStackTrace$6204b72985f9038d, 0, r2);
	_JC_REF_FIELD(env, r2, java_lang_Throwable, detailMessage) = r3;
	_JC_THROW(env, r2);

label1:
	_JC_ACTIVE_USE(env, gnu_classpath_SystemProperties);
	r5 = _JC_STATIC_FIELD(env, gnu_classpath_SystemProperties, properties, 1);
	r4 = _JC_INVOKE_VIRTUAL(env, java_util_Properties, getProperty$17fb18205ea95f87, r5, r0);
	_JC_STATIC_FIELD(env, soot_util_StringTools, lineSeparator, 1) = r4;
	return;
}

//
// public static char getCFormatChar(char)
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$getCFormatChar$b6346fd39e944fe3[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$getCFormatChar$b6346fd39e944fe3[] = { 
_JC_TYPE_CHAR, _JC_TYPE_CHAR };

static _jc_type *const _jc_soot_util_StringTools$param_types$getCFormatChar$b6346fd39e944fe3[] = {
	&_jc_char$prim$type
};

_jc_method _jc_soot_util_StringTools$method_info$getCFormatChar$b6346fd39e944fe3 = {
	.name=			"getCFormatChar",
	.signature=		"(C)C",
	.class=			&_jc_soot_util_StringTools$type,
	.param_types=		&_jc_soot_util_StringTools$param_types$getCFormatChar$b6346fd39e944fe3,
	.return_type=		&_jc_char$prim$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$getCFormatChar$b6346fd39e944fe3,
	.signature_hash=	_JC_JLONG(0xb6346fd39e944fe3),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_util_StringTools$method$getCFormatChar$b6346fd39e944fe3,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	15,
	      .table=	_jc_soot_util_StringTools$linenum_table$getCFormatChar$b6346fd39e944fe3
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, getCFormatChar$b6346fd39e944fe3);

jchar
_jc_soot_util_StringTools$method$getCFormatChar$b6346fd39e944fe3(_jc_env *const env, jchar param0)
{
	jchar c0;

	c0 = param0;
	_JC_LINE_NUMBER(182);				// 0
	switch (c0) {
	case 34:
		goto label4;
	case 39:
		goto label5;
	case 98:
		goto label3;
	case 110:
		goto label0;
	case 114:
		goto label2;
	case 116:
		goto label1;
	default:
		goto label6;
	}

label0:
	_JC_LINE_NUMBER(184);				// 1
	c0 = 10;
	_JC_LINE_NUMBER(185);				// 2
	goto label7;

label1:
	_JC_LINE_NUMBER(187);				// 3
	c0 = 9;
	_JC_LINE_NUMBER(188);				// 4
	goto label7;

label2:
	_JC_LINE_NUMBER(190);				// 5
	c0 = 13;
	_JC_LINE_NUMBER(191);				// 6
	goto label7;

label3:
	_JC_LINE_NUMBER(193);				// 7
	c0 = 8;
	_JC_LINE_NUMBER(194);				// 8
	goto label7;

label4:
	_JC_LINE_NUMBER(196);				// 9
	c0 = 34;
	_JC_LINE_NUMBER(197);				// 10
	goto label7;

label5:
	_JC_LINE_NUMBER(199);				// 11
	c0 = 39;
	_JC_LINE_NUMBER(200);				// 12
	goto label7;

label6:
	_JC_LINE_NUMBER(203);				// 13
	c0 = 0;

label7:
	_JC_LINE_NUMBER(206);				// 14
	return c0;
}

//
// public static java.lang.String getEscapedStringOf(java.lang.String)
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$getEscapedStringOf$d4093770200b4055[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$getEscapedStringOf$d4093770200b4055[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_util_StringTools$param_types$getEscapedStringOf$d4093770200b4055[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_util_StringTools$method_info$getEscapedStringOf$d4093770200b4055 = {
	.name=			"getEscapedStringOf",
	.signature=		"(Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_soot_util_StringTools$type,
	.param_types=		&_jc_soot_util_StringTools$param_types$getEscapedStringOf$d4093770200b4055,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$getEscapedStringOf$d4093770200b4055,
	.signature_hash=	_JC_JLONG(0xd4093770200b4055),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_util_StringTools$method$getEscapedStringOf$d4093770200b4055,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	16,
	      .table=	_jc_soot_util_StringTools$linenum_table$getEscapedStringOf$d4093770200b4055
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, getEscapedStringOf$d4093770200b4055);

_jc_java_lang_String$object *
_jc_soot_util_StringTools$method$getEscapedStringOf$d4093770200b4055(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jchar c12;
	jchar c2;
	jchar c8;
	jint i0;
	jint i1;
	jint i11;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	jint i9;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *r10;
	_jc_char_array *r11;
	struct _jc_java_lang_StringBuffer$object *r12;
	struct _jc_java_lang_StringBuffer$object *r13;
	struct _jc_java_lang_String$object *r14;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_lang_VMThrowable$object *r16;
	struct _jc_java_lang_String$object *r17;
	_jc_char_array *r18;
	struct _jc_java_lang_StringBuffer$object *r2;
	struct _jc_java_lang_StringIndexOutOfBoundsException$object *r20;
	_jc_char_array *r21;
	struct _jc_java_lang_String$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	_jc_char_array *r6;
	_jc_char_array *r7;
	_jc_char_array *r8;
	_jc_char_array *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(41);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r6 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r6;
	_JC_LINE_NUMBER(42);				// 1
	r2 = _JC_NEW(env, java_lang_StringBuffer);
	r7 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r2, java_lang_StringBuffer, value) = r7;
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i5 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	r8 = _JC_NEW_PRIM_ARRAY(env, char, 1, i5);
	r9 = _JC_REF_FIELD(env, r0, java_lang_String, value);
	i5 = _JC_PRIM_FIELD(env, r0, java_lang_String, offset);
	i6 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r9, i5, r8, 0, i6);
	_JC_LINE_NUMBER(46);				// 2
	r0 = _JC_STATIC_FIELD(env, soot_util_StringTools, lineSeparator, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i7 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	if (0 < i7)
		goto label0;
	r10 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	r12 = _JC_NEW(env, java_lang_StringBuffer);
	r17 = _JC_STRING(env, "String index out of range: ");
	i9 = _JC_PRIM_FIELD(env, r17, java_lang_String, count);
	_JC_PRIM_FIELD(env, r12, java_lang_StringBuffer, count) = i9;
	i9 = _JC_PRIM_FIELD(env, r12, java_lang_StringBuffer, count);
	i9 = i9 + 16;
	r18 = _JC_NEW_PRIM_ARRAY(env, char, 1, i9);
	_JC_REF_FIELD(env, r12, java_lang_StringBuffer, value) = r18;
	i9 = _JC_PRIM_FIELD(env, r12, java_lang_StringBuffer, count);
	r18 = _JC_REF_FIELD(env, r12, java_lang_StringBuffer, value);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, getChars$c684dea7317ff063, 0, r17, 0, i9, r18, 0);
	r14 = _JC_INVOKE_STATIC(env, java_lang_Integer, toString$80d919d12afaaa2b, 0, 0, 10);
	r13 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r12, r14);
	_JC_EXPLICIT_NULL_CHECK(env, r13);
	r15 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r15, r13);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, cause) = r10;
	r16 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r10);
	_JC_REF_FIELD(env, r10, java_lang_Throwable, vmState) = r16;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r10, java_lang_Throwable, detailMessage) = r15;
	_JC_THROW(env, r10);

label0:
	r11 = _JC_REF_FIELD(env, r0, java_lang_String, value);
	i7 = _JC_PRIM_FIELD(env, r0, java_lang_String, offset);
	i7 = i7 + 0;
	c8 = _JC_PRIM_ELEMENT(env, char, r11, i7, 1, 1);
	_JC_LINE_NUMBER(47);				// 3
	i0 = -1;
	_JC_LINE_NUMBER(49);				// 4
	r0 = _JC_STATIC_FIELD(env, soot_util_StringTools, lineSeparator, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i4 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	if (i4 != 2)
		goto label2;
	_JC_LINE_NUMBER(50);				// 5
	r0 = _JC_STATIC_FIELD(env, soot_util_StringTools, lineSeparator, 1);
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i11 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	if (1 < i11)
		goto label1;
	r20 = _JC_NEW(env, java_lang_StringIndexOutOfBoundsException);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringIndexOutOfBoundsException, _init$7f1776288300b98d, 0, r20, 1);
	_JC_THROW(env, r20);

label1:
	r21 = _JC_REF_FIELD(env, r0, java_lang_String, value);
	i11 = _JC_PRIM_FIELD(env, r0, java_lang_String, offset);
	i11 = i11 + 1;
	c12 = _JC_PRIM_ELEMENT(env, char, r21, i11, 1, 1);
	i0 = c12;

label2:
	_JC_LINE_NUMBER(52);				// 6
	i1 = 0;

label3:
	i3 = _JC_ARRAY_LENGTH(env, r8);
	if (i1 >= i3)
		goto label10;
	_JC_LINE_NUMBER(54);				// 7
	c2 = _JC_PRIM_ELEMENT(env, char, r8, i1, 0, 0);
	_JC_LINE_NUMBER(55);				// 8
	if (c2 < 32)
		goto label4;
	if (c2 <= 126)
		goto label5;

label4:
	if (c2 == c8)
		goto label5;
	if (c2 != i0)
		goto label6;

label5:
	_JC_LINE_NUMBER(57);				// 9
	c2 = (jchar)c2;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, c2);
	_JC_LINE_NUMBER(59);				// 10
	goto label9;

label6:
	_JC_LINE_NUMBER(62);				// 11
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, setLength$1c9b2a0f8424f0fc, 0, r2, 0);
	_JC_ACTIVE_USE(env, java_lang_Integer);
	r3 = _JC_INVOKE_STATIC(env, java_lang_Integer, toUnsignedString$0e382aff778c29b9, 1, c2, 4);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r2, r3);

label7:
	_JC_LINE_NUMBER(65);				// 12
	i3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, length$5ea4559400f436b9, 0, r2);
	if (i3 >= 4)
		goto label8;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, insert$2e50ba6574324aec, 0, r2, 0, _JC_STRING(env, "0"));
	_JC_LINE_NUMBER(66);				// 13
	_JC_PERIODIC_CHECK(env);
	goto label7;

label8:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, insert$2e50ba6574324aec, 0, r2, 0, _JC_STRING(env, "\\u"));
	r4 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r4, r2);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r4);

label9:
	_JC_LINE_NUMBER(52);				// 14
	i1 = i1 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label3;

label10:
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r1);
	_JC_LINE_NUMBER(72);				// 15
	return r5;
}

//
// public static java.lang.String getQuotedStringOf(java.lang.String)
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$getQuotedStringOf$831b19c537e0dc75[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$getQuotedStringOf$831b19c537e0dc75[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_util_StringTools$param_types$getQuotedStringOf$831b19c537e0dc75[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_util_StringTools$method_info$getQuotedStringOf$831b19c537e0dc75 = {
	.name=			"getQuotedStringOf",
	.signature=		"(Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_soot_util_StringTools$type,
	.param_types=		&_jc_soot_util_StringTools$param_types$getQuotedStringOf$831b19c537e0dc75,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$getQuotedStringOf$831b19c537e0dc75,
	.signature_hash=	_JC_JLONG(0x831b19c537e0dc75),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_util_StringTools$method$getQuotedStringOf$831b19c537e0dc75,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	18,
	      .table=	_jc_soot_util_StringTools$linenum_table$getQuotedStringOf$831b19c537e0dc75
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, getQuotedStringOf$831b19c537e0dc75);

_jc_java_lang_String$object *
_jc_soot_util_StringTools$method$getQuotedStringOf$831b19c537e0dc75(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jchar c1;
	jint i0;
	jint i2;
	jint i3;
	jint i4;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_String$object *r3;
	_jc_char_array *r4;
	_jc_char_array *r6;
	_jc_char_array *r7;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(86);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r4 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r4;
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i3 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	r6 = _JC_NEW_PRIM_ARRAY(env, char, 1, i3);
	r7 = _JC_REF_FIELD(env, r0, java_lang_String, value);
	i3 = _JC_PRIM_FIELD(env, r0, java_lang_String, offset);
	i4 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	_JC_INVOKE_STATIC(env, java_lang_VMSystem, arraycopy$4286a72d57744cd8, 0, r7, i3, r6, 0, i4);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\""));
	_JC_LINE_NUMBER(91);				// 1
	i0 = 0;

label0:
	i2 = _JC_ARRAY_LENGTH(env, r6);
	if (i0 >= i2)
		goto label8;
	_JC_LINE_NUMBER(93);				// 2
	c1 = _JC_PRIM_ELEMENT(env, char, r6, i0, 0, 0);
	_JC_LINE_NUMBER(95);				// 3
	if (c1 != 92)
		goto label1;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\\\\"));
	_JC_LINE_NUMBER(96);				// 4
	goto label7;

label1:
	_JC_LINE_NUMBER(97);				// 5
	if (c1 != 39)
		goto label2;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\\'"));
	_JC_LINE_NUMBER(98);				// 6
	goto label7;

label2:
	_JC_LINE_NUMBER(99);				// 7
	if (c1 != 34)
		goto label3;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\\\""));
	_JC_LINE_NUMBER(100);				// 8
	goto label7;

label3:
	_JC_LINE_NUMBER(101);				// 9
	if (c1 != 10)
		goto label4;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\\n"));
	_JC_LINE_NUMBER(102);				// 10
	goto label7;

label4:
	_JC_LINE_NUMBER(103);				// 11
	if (c1 != 9)
		goto label5;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\\t"));
	_JC_LINE_NUMBER(104);				// 12
	goto label7;

label5:
	_JC_LINE_NUMBER(105);				// 13
	if (c1 < 32)
		goto label6;
	if (c1 > 126)
		goto label6;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, c1);
	_JC_LINE_NUMBER(106);				// 14
	goto label7;

label6:
	_JC_LINE_NUMBER(109);				// 15
	r0 = _JC_INVOKE_STATIC(env, soot_util_StringTools, getUnicodeStringFromChar$03b50b4f02c07298, 0, c1);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r0);

label7:
	_JC_LINE_NUMBER(91);				// 16
	i0 = i0 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label0;

label8:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\""));
	r3 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r3, r1);
	_JC_LINE_NUMBER(113);				// 17
	return r3;
}

//
// public static java.lang.String getUnEscapedStringOf(java.lang.String)
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$getUnEscapedStringOf$5d61f69969ff746b[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$getUnEscapedStringOf$5d61f69969ff746b[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_util_StringTools$param_types$getUnEscapedStringOf$5d61f69969ff746b[] = {
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_util_StringTools$method_info$getUnEscapedStringOf$5d61f69969ff746b = {
	.name=			"getUnEscapedStringOf",
	.signature=		"(Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_soot_util_StringTools$type,
	.param_types=		&_jc_soot_util_StringTools$param_types$getUnEscapedStringOf$5d61f69969ff746b,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$getUnEscapedStringOf$5d61f69969ff746b,
	.signature_hash=	_JC_JLONG(0x5d61f69969ff746b),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_util_StringTools$method$getUnEscapedStringOf$5d61f69969ff746b,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	17,
	      .table=	_jc_soot_util_StringTools$linenum_table$getUnEscapedStringOf$5d61f69969ff746b
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, getUnEscapedStringOf$5d61f69969ff746b);

_jc_java_lang_String$object *
_jc_soot_util_StringTools$method$getUnEscapedStringOf$5d61f69969ff746b(_jc_env *const env, _jc_java_lang_String$object *param0)
{
	jchar c0;
	jchar c12;
	jchar c15;
	jchar c18;
	jchar c2;
	jchar c21;
	jchar c3;
	jchar c9;
	jint i1;
	jint i10;
	jint i11;
	jint i13;
	jint i14;
	jint i16;
	jint i17;
	jint i19;
	jint i20;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	jint i8;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	_jc_char_array *r10;
	struct _jc_java_lang_VMThrowable$object *r11;
	struct _jc_java_lang_String$object *r12;
	struct _jc_java_lang_String$object *r13;
	struct _jc_java_lang_String$object *r15;
	struct _jc_java_text_StringCharacterIterator$object *r2;
	struct _jc_java_lang_StringBuffer$object *r3;
	struct _jc_java_lang_RuntimeException$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	struct _jc_java_lang_String$object *r7;
	_jc_char_array *r8;
	_jc_char_array *r9;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	_JC_LINE_NUMBER(145);				// 0
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r8 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r8;
	_JC_LINE_NUMBER(146);				// 1
	r2 = _JC_NEW(env, java_text_StringCharacterIterator);
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i5 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	_JC_INVOKE_NONVIRTUAL(env, java_text_StringCharacterIterator, _init$aea90b4a9c7c9ca6, 0, r2, r0, 0, i5, 0);
	i6 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, begin);
	_JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index) = i6;
	i7 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	i8 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, end);
	if (i7 >= i8)
		goto label0;
	r12 = _JC_REF_FIELD(env, r2, java_text_StringCharacterIterator, text);
	i8 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	c9 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, charAt$bb9507ba35769182, 1, r12, i8);
	goto label1;

label0:
	c9 = (jchar)-1;

label1:
	c0 = c9;

label2:
	_JC_LINE_NUMBER(148);				// 2
	if (c0 == 65535)
		goto label18;
	_JC_LINE_NUMBER(150);				// 3
	if (c0 == 92)
		goto label3;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, c0);
	_JC_LINE_NUMBER(151);				// 4
	goto label17;

label3:
	i10 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	i11 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, end);
	if (i10 != i11)
		goto label4;
	c12 = (jchar)-1;
	c2 = c12;
	goto label7;

label4:
	i11 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	i11 = i11 + 1;
	_JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index) = i11;
	i13 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	i14 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, end);
	if (i13 >= i14)
		goto label5;
	r13 = _JC_REF_FIELD(env, r2, java_text_StringCharacterIterator, text);
	i14 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	c15 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, charAt$bb9507ba35769182, 1, r13, i14);
	goto label6;

label5:
	c15 = (jchar)-1;

label6:
	c2 = c15;

label7:
	_JC_LINE_NUMBER(157);				// 5
	if (c2 != 92)
		goto label8;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, c2);
	_JC_LINE_NUMBER(158);				// 6
	goto label17;

label8:
	_JC_LINE_NUMBER(159);				// 7
	c3 = _JC_INVOKE_STATIC(env, soot_util_StringTools, getCFormatChar$b6346fd39e944fe3, 0, c2);
	if (c3 == 0)
		goto label9;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, c3);
	_JC_LINE_NUMBER(160);				// 8
	goto label17;

label9:
	_JC_LINE_NUMBER(161);				// 9
	if (c2 != 117)
		goto label16;
	_JC_LINE_NUMBER(163);				// 10
	r3 = _JC_NEW(env, java_lang_StringBuffer);
	r9 = _JC_NEW_PRIM_ARRAY(env, char, 1, 4);
	_JC_REF_FIELD(env, r3, java_lang_StringBuffer, value) = r9;
	_JC_LINE_NUMBER(164);				// 11
	i1 = 0;

label10:
	if (i1 >= 4)
		goto label15;
	i16 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	i17 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, end);
	if (i16 != i17)
		goto label11;
	c18 = (jchar)-1;
	c3 = c18;
	goto label14;

label11:
	i17 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	i17 = i17 + 1;
	_JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index) = i17;
	i19 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	i20 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, end);
	if (i19 >= i20)
		goto label12;
	r15 = _JC_REF_FIELD(env, r2, java_text_StringCharacterIterator, text);
	i20 = _JC_PRIM_FIELD(env, r2, java_text_StringCharacterIterator, index);
	c21 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, charAt$bb9507ba35769182, 1, r15, i20);
	goto label13;

label12:
	c21 = (jchar)-1;

label13:
	c3 = c21;

label14:
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r3, c3);
	i1 = i1 + 1;
	_JC_PERIODIC_CHECK(env);
	goto label10;

label15:
	r5 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r5, r3);
	_JC_ACTIVE_USE(env, java_lang_Integer);
	i4 = _JC_INVOKE_STATIC(env, java_lang_Integer, parseInt$09e508ce4e7428b2, 1, r5, 16, 0);
	_JC_LINE_NUMBER(167);				// 12
	c3 = (jchar)i4;
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r1, c3);
	_JC_LINE_NUMBER(168);				// 13
	goto label17;

label16:
	_JC_LINE_NUMBER(170);				// 14
	r4 = _JC_NEW(env, java_lang_RuntimeException);
	r3 = _JC_NEW(env, java_lang_StringBuffer);
	r10 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r3, java_lang_StringBuffer, value) = r10;
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r3, _JC_STRING(env, "Unexpected char: "));
	r3 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$9450b16e89f0618d, 0, r3, c2);
	r6 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r6, r3);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, cause) = r4;
	r11 = _JC_INVOKE_STATIC(env, java_lang_VMThrowable, fillInStackTrace$78894ac70fa4c0a5, 0, r4);
	_JC_REF_FIELD(env, r4, java_lang_Throwable, vmState) = r11;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, stackTrace) = _JC_NULL;
	_JC_REF_FIELD(env, r4, java_lang_Throwable, detailMessage) = r6;
	_JC_THROW(env, r4);

label17:
	_JC_LINE_NUMBER(148);				// 15
	c0 = _JC_INVOKE_NONVIRTUAL(env, java_text_StringCharacterIterator, next$830e4cf9e6bf8b68, 0, r2);
	_JC_PERIODIC_CHECK(env);
	goto label2;

label18:
	r7 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r7, r1);
	_JC_LINE_NUMBER(174);				// 16
	return r7;
}

//
// public static java.lang.String getUnicodeStringFromChar(char)
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$getUnicodeStringFromChar$03b50b4f02c07298[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$getUnicodeStringFromChar$03b50b4f02c07298[] = { 
_JC_TYPE_CHAR, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_util_StringTools$param_types$getUnicodeStringFromChar$03b50b4f02c07298[] = {
	&_jc_char$prim$type
};

_jc_method _jc_soot_util_StringTools$method_info$getUnicodeStringFromChar$03b50b4f02c07298 = {
	.name=			"getUnicodeStringFromChar",
	.signature=		"(C)Ljava/lang/String;",
	.class=			&_jc_soot_util_StringTools$type,
	.param_types=		&_jc_soot_util_StringTools$param_types$getUnicodeStringFromChar$03b50b4f02c07298,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$getUnicodeStringFromChar$03b50b4f02c07298,
	.signature_hash=	_JC_JLONG(0x3b50b4f02c07298),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_util_StringTools$method$getUnicodeStringFromChar$03b50b4f02c07298,
	.num_parameters=	1,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	10,
	      .table=	_jc_soot_util_StringTools$linenum_table$getUnicodeStringFromChar$03b50b4f02c07298
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, getUnicodeStringFromChar$03b50b4f02c07298);

_jc_java_lang_String$object *
_jc_soot_util_StringTools$method$getUnicodeStringFromChar$03b50b4f02c07298(_jc_env *const env, jchar param0)
{
	jchar c0;
	jint i1;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_StringBuffer$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_String$object *r3;
	_jc_char_array *r4;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	c0 = param0;
	_JC_ACTIVE_USE(env, java_lang_Integer);
	r2 = _JC_INVOKE_STATIC(env, java_lang_Integer, toUnsignedString$0e382aff778c29b9, 1, c0, 4);
	_JC_LINE_NUMBER(121);				// 0
	r0 = _JC_NULL;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	i1 = _JC_PRIM_FIELD(env, r2, java_lang_String, count);
	_JC_LINE_NUMBER(123);				// 1
	switch (i1) {
	case 1:
		goto label0;
	case 2:
		goto label1;
	case 3:
		goto label2;
	case 4:
		goto label3;
	default:
		goto label4;
	}

label0:
	_JC_LINE_NUMBER(125);				// 2
	r0 = _JC_STRING(env, "000");
	_JC_LINE_NUMBER(126);				// 3
	goto label4;

label1:
	_JC_LINE_NUMBER(128);				// 4
	r0 = _JC_STRING(env, "00");
	_JC_LINE_NUMBER(129);				// 5
	goto label4;

label2:
	_JC_LINE_NUMBER(131);				// 6
	r0 = _JC_STRING(env, "0");
	_JC_LINE_NUMBER(132);				// 7
	goto label4;

label3:
	_JC_LINE_NUMBER(134);				// 8
	r0 = _JC_STRING(env, "");

label4:
	_JC_LINE_NUMBER(138);				// 9
	r1 = _JC_NEW(env, java_lang_StringBuffer);
	r4 = _JC_NEW_PRIM_ARRAY(env, char, 1, 16);
	_JC_REF_FIELD(env, r1, java_lang_StringBuffer, value) = r4;
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, _JC_STRING(env, "\\u"));
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r0);
	r1 = _JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r1, r2);
	r3 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r3, r1);
	return r3;
}

//
// public static java.lang.String replaceAll(java.lang.String, java.lang.String, java.lang.String)
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$replaceAll$1d078442fa37992f[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$replaceAll$1d078442fa37992f[] = { 
_JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE, _JC_TYPE_REFERENCE };

static _jc_type *const _jc_soot_util_StringTools$param_types$replaceAll$1d078442fa37992f[] = {
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type,
	&_jc_java_lang_String$type
};

_jc_method _jc_soot_util_StringTools$method_info$replaceAll$1d078442fa37992f = {
	.name=			"replaceAll",
	.signature=		"(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)Ljava/lang/String;",
	.class=			&_jc_soot_util_StringTools$type,
	.param_types=		&_jc_soot_util_StringTools$param_types$replaceAll$1d078442fa37992f,
	.return_type=		&_jc_java_lang_String$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$replaceAll$1d078442fa37992f,
	.signature_hash=	_JC_JLONG(0x1d078442fa37992f),
	.access_flags=		_JC_ACC_PUBLIC|_JC_ACC_STATIC,
	.function=		&_jc_soot_util_StringTools$method$replaceAll$1d078442fa37992f,
	.num_parameters=	3,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	13,
	      .table=	_jc_soot_util_StringTools$linenum_table$replaceAll$1d078442fa37992f
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, replaceAll$1d078442fa37992f);

_jc_java_lang_String$object *
_jc_soot_util_StringTools$method$replaceAll$1d078442fa37992f(_jc_env *const env, _jc_java_lang_String$object *param0, _jc_java_lang_String$object *param1, _jc_java_lang_String$object *param2)
{
	jint i0;
	jint i1;
	jint i2;
	jint i3;
	jint i4;
	jint i5;
	jint i6;
	jint i7;
	jint i8;
	struct _jc_java_lang_String$object *r0;
	struct _jc_java_lang_String$object *r1;
	struct _jc_java_lang_String$object *r2;
	struct _jc_java_lang_StringBuffer$object *r3;
	struct _jc_java_lang_String$object *r4;
	struct _jc_java_lang_String$object *r5;
	struct _jc_java_lang_String$object *r6;
	_jc_char_array *r7;
	_jc_char_array *r8;

	// Check for stack overflow
	_JC_STACK_OVERFLOW_CHECK(env);

	r0 = param0;
	r1 = param1;
	r2 = param2;
	_JC_EXPLICIT_NULL_CHECK(env, r1);
	i3 = _JC_PRIM_FIELD(env, r1, java_lang_String, count);
	_JC_LINE_NUMBER(232);				// 0
	if (i3 > 0)
		goto label0;
	_JC_LINE_NUMBER(233);				// 1
	return r0;

label0:
	_JC_EXPLICIT_NULL_CHECK(env, r0);
	i4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, indexOf$da92d2b306f84294, 0, r0, r1, 0);
	i0 = i4;
	_JC_LINE_NUMBER(237);				// 2
	if (i4 >= 0)
		goto label1;
	_JC_LINE_NUMBER(238);				// 3
	return r0;

label1:
	_JC_LINE_NUMBER(240);				// 4
	i1 = 0;
	_JC_EXPLICIT_NULL_CHECK(env, r2);
	i5 = _JC_PRIM_FIELD(env, r2, java_lang_String, count);
	_JC_LINE_NUMBER(242);				// 5
	if (i3 >= i5)
		goto label2;
	_JC_LINE_NUMBER(243);				// 6
	r3 = _JC_NEW(env, java_lang_StringBuffer);
	i6 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	r7 = _JC_NEW_PRIM_ARRAY(env, char, 1, i6);
	_JC_REF_FIELD(env, r3, java_lang_StringBuffer, value) = r7;
	goto label3;

label2:
	_JC_LINE_NUMBER(245);				// 7
	r3 = _JC_NEW(env, java_lang_StringBuffer);
	i7 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	i2 = i7 * 2;
	r8 = _JC_NEW_PRIM_ARRAY(env, char, 1, i2);
	_JC_REF_FIELD(env, r3, java_lang_StringBuffer, value) = r8;

label3:
	_JC_LINE_NUMBER(249);				// 8
	r4 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r0, i1, i0);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r3, r4);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r3, r2);
	_JC_LINE_NUMBER(251);				// 9
	i1 = i0 + i3;
	_JC_LINE_NUMBER(252);				// 10
	i0 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, indexOf$da92d2b306f84294, 0, r0, r1, i1);
	_JC_LINE_NUMBER(253);				// 11
	if (i0 >= 0) {
		_JC_PERIODIC_CHECK(env);
		goto label3;
	}
	i8 = _JC_PRIM_FIELD(env, r0, java_lang_String, count);
	r5 = _JC_INVOKE_NONVIRTUAL(env, java_lang_String, substring$df0d95f5ebfea7dc, 0, r0, i1, i8);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_StringBuffer, append$7d7ff98bb1f0cb55, 0, r3, r5);
	r6 = _JC_NEW(env, java_lang_String);
	_JC_INVOKE_NONVIRTUAL(env, java_lang_String, _init$aa54f0755ac8f3ce, 0, r6, r3);
	_JC_LINE_NUMBER(256);				// 12
	return r6;
}

/************************************************************************
 *			       Constructors				*
 ************************************************************************/

//
// public void <init>()
//

static _jc_linenum _jc_soot_util_StringTools$linenum_table$_init$52f4ad9f2989aeee[];

static const unsigned char _jc_soot_util_StringTools$param_ptypes$_init$52f4ad9f2989aeee[] = { 
_JC_TYPE_VOID };

_jc_method _jc_soot_util_StringTools$method_info$_init$52f4ad9f2989aeee = {
	.name=			"<init>",
	.signature=		"()V",
	.class=			&_jc_soot_util_StringTools$type,
	.return_type=		&_jc_void$prim$type,
	.param_ptypes=		&_jc_soot_util_StringTools$param_ptypes$_init$52f4ad9f2989aeee,
	.signature_hash=	_JC_JLONG(0x52f4ad9f2989aeee),
	.access_flags=		_JC_ACC_PUBLIC,
	.function=		&_jc_soot_util_StringTools$method$_init$52f4ad9f2989aeee,
	.num_parameters=	0,
	.u= { .exec= {
	  .u= {
	    .linenum= {
	      .len=	1,
	      .table=	_jc_soot_util_StringTools$linenum_table$_init$52f4ad9f2989aeee
	    },
	  },
	} },
};

_JC_LINENUM_TABLE(soot_util_StringTools, _init$52f4ad9f2989aeee);

void
_jc_soot_util_StringTools$method$_init$52f4ad9f2989aeee(_jc_env *const env, _jc_soot_util_StringTools$object *this)
{
	struct _jc_soot_util_StringTools$object *r0;

	r0 = this;
	_JC_LINE_NUMBER(76);				// 0
	return;
}

/************************************************************************
 *			       Method list				*
 ************************************************************************/

// Methods
static _jc_method *const _jc_soot_util_StringTools$methods[] = {
	&_jc_soot_util_StringTools$method_info$_clinit$a816641e0ba8bfef,
	&_jc_soot_util_StringTools$method_info$_init$52f4ad9f2989aeee,
	&_jc_soot_util_StringTools$method_info$getCFormatChar$b6346fd39e944fe3,
	&_jc_soot_util_StringTools$method_info$getEscapedStringOf$d4093770200b4055,
	&_jc_soot_util_StringTools$method_info$getQuotedStringOf$831b19c537e0dc75,
	&_jc_soot_util_StringTools$method_info$getUnEscapedStringOf$5d61f69969ff746b,
	&_jc_soot_util_StringTools$method_info$getUnicodeStringFromChar$03b50b4f02c07298,
	&_jc_soot_util_StringTools$method_info$replaceAll$1d078442fa37992f
};

/************************************************************************
 *			  Class fields structure			*
 ************************************************************************/

_jc_soot_util_StringTools$fields_struct _jc_soot_util_StringTools$class_fields = { };

/************************************************************************
 *			  Instanceof hash table				*
 ************************************************************************/

#if _JC_INSTANCEOF_HASHSIZE != 128
#error "_JC_INSTANCEOF_HASHSIZE has the wrong value (should be 128)"
#endif

// Instanceof hash table buckets
static _jc_type *const _jc_soot_util_StringTools$instanceof_hash_bucket_5[] = {
	&_jc_soot_util_StringTools$type,
	_JC_NULL
};
static _jc_type *const _jc_soot_util_StringTools$instanceof_hash_bucket_113[] = {
	&_jc_java_lang_Object$type,
	_JC_NULL
};

// Instanceof hash table
static _jc_type *const *const _jc_soot_util_StringTools$instanceof_hash_table[_JC_INSTANCEOF_HASHSIZE] = {
	[5]=	_jc_soot_util_StringTools$instanceof_hash_bucket_5,
	[113]=	_jc_soot_util_StringTools$instanceof_hash_bucket_113
};

/************************************************************************
 *			     Dependency list				*
 ************************************************************************/

// Class dependency info
static _jc_class_depend _jc_soot_util_StringTools$class_depends[] = {
	{ "gnu/classpath/SystemProperties",	_JC_JLONG(0xc3e37402f8a0600b) },
	{ "java/lang/Class",	_JC_JLONG(0xbf29ff960d5ec1d0) },
	{ "java/lang/Exception",	_JC_JLONG(0xc5feb325780a6cd7) },
	{ "java/lang/IllegalArgumentException",	_JC_JLONG(0x680cf34d05feb5a1) },
	{ "java/lang/IndexOutOfBoundsException",	_JC_JLONG(0x3cdfed1e0ad1a3d6) },
	{ "java/lang/Integer",	_JC_JLONG(0x41f43e69651f01be) },
	{ "java/lang/Object",	_JC_JLONG(0x2a7152deee1944f1) },
	{ "java/lang/RuntimeException",	_JC_JLONG(0x4f5534a987354d1d) },
	{ "java/lang/SecurityManager",	_JC_JLONG(0xd38282f3d5f80887) },
	{ "java/lang/String",	_JC_JLONG(0xc80f4aedd95be265) },
	{ "java/lang/StringBuffer",	_JC_JLONG(0x94d357637b968dda) },
	{ "java/lang/StringIndexOutOfBoundsException",	_JC_JLONG(0xbb7f6fdd2bd0e6b2) },
	{ "java/lang/System",	_JC_JLONG(0xa0a8fafccf4b2db9) },
	{ "java/lang/Throwable",	_JC_JLONG(0x3be5c3c4fdd59a1e) },
	{ "java/lang/VMSystem",	_JC_JLONG(0x4d1cebae0bdda058) },
	{ "java/lang/VMThrowable",	_JC_JLONG(0xc8d6a6ffc5c1acc1) },
	{ "java/text/StringCharacterIterator",	_JC_JLONG(0x297bcc893ad53f24) },
	{ "java/util/Properties",	_JC_JLONG(0x884c3edb343dfb63) },
};

/************************************************************************
 *				Class info				*
 ************************************************************************/

// Class info
_jc_soot_util_StringTools$vtype _jc_soot_util_StringTools$type = {
    .type= {
	.name=			"soot/util/StringTools",
	.superclass=		&_jc_java_lang_Object$type,
	.access_flags=		_JC_ACC_PUBLIC,
	.flags=			_JC_TYPE_REFERENCE,
	.imethod_hash_table=	_jc_empty_imethod_table,
	.imethod_quick_table=	_jc_empty_quick_table,
	.u= {
	    .nonarray= {
		.block_size_index=	_JC_LIBJC_VERSION,
		.num_vmethods=		11,
		.hash=			_JC_JLONG(0x8e89953898085705),
		.source_file=		"StringTools.java",
		.instance_size=		sizeof(_jc_soot_util_StringTools$refs) + sizeof(_jc_soot_util_StringTools$object),
		.num_virtual_refs=	0,
		.num_fields=		sizeof(_jc_soot_util_StringTools$fields) / sizeof(*_jc_soot_util_StringTools$fields),
		.fields=		_jc_soot_util_StringTools$fields,
		.num_methods=		sizeof(_jc_soot_util_StringTools$methods) / sizeof(*_jc_soot_util_StringTools$methods),
		.methods=		_jc_soot_util_StringTools$methods,
		.instanceof_hash_table=	_jc_soot_util_StringTools$instanceof_hash_table,
		.class_fields=		&_jc_soot_util_StringTools$class_fields,
		.num_class_depends=		sizeof(_jc_soot_util_StringTools$class_depends) / sizeof(*_jc_soot_util_StringTools$class_depends),
		.class_depends=		_jc_soot_util_StringTools$class_depends,
	    }
	}
    },
    .vtable= {
	.java_lang_Object= {
	    .clone$b75f2713d6705f70=
		&_jc_java_lang_Object$method$clone$b75f2713d6705f70,
	    .equals$8a15e0625571c581=
		&_jc_java_lang_Object$method$equals$8a15e0625571c581,
	    .finalize$660a5b5b608ff21f=
		&_jc_java_lang_Object$method$finalize$660a5b5b608ff21f,
	    .getClass$1f1ddb358c8ea7be=
		&_jc_java_lang_Object$method$getClass$1f1ddb358c8ea7be,
	    .hashCode$53152098849316df=
		&_jc_java_lang_Object$method$hashCode$53152098849316df,
	    .notify$36cb33b21c887fbf=
		&_jc_java_lang_Object$method$notify$36cb33b21c887fbf,
	    .notifyAll$3965af7f7c4f2978=
		&_jc_java_lang_Object$method$notifyAll$3965af7f7c4f2978,
	    .toString$7ea43b33b80a3070=
		&_jc_java_lang_Object$method$toString$7ea43b33b80a3070,
	    .wait$b5c8f990d7547e7d=
		&_jc_java_lang_Object$method$wait$b5c8f990d7547e7d,
	    .wait$5aedd5d0ce2db494=
		&_jc_java_lang_Object$method$wait$5aedd5d0ce2db494,
	    .wait$5175bc722fb3a6fa=
		&_jc_java_lang_Object$method$wait$5175bc722fb3a6fa,
	},
	.soot_util_StringTools= {
	},
    }
};

